package com.up.sell.config;
 
import java.io.Writer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.core.config.Configuration;
import org.apache.logging.log4j.core.config.LoggerConfig;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

 
/**
 * 动态修改log4j日志级别
 */
@Controller
@RequestMapping(value = "/logger")
public class LoggerController {  

	/**
     * LOG4j2动态修改包名的日志级别
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/level")
    @ResponseBody
    public String updateLogbackLevelj( @RequestParam(value="level") String level) throws Exception {
        String msg = "success";
        level = level.toLowerCase();
        org.apache.logging.log4j.core.LoggerContext ctx = (org.apache.logging.log4j.core.LoggerContext) LogManager.getContext(false);
        Configuration config = ctx.getConfiguration();
        LoggerConfig loggerConfig = config.getLoggerConfig(LogManager.ROOT_LOGGER_NAME);
       switch (level) {
           case "trace":
               loggerConfig.setLevel(org.apache.logging.log4j.Level.TRACE);
               break;
           case "debug":
               loggerConfig.setLevel(org.apache.logging.log4j.Level.DEBUG);
               break;
           case "info":
               loggerConfig.setLevel(org.apache.logging.log4j.Level.INFO);
               break;
           case "warn":
               loggerConfig.setLevel(org.apache.logging.log4j.Level.WARN);
               break;
           case "error":
               loggerConfig.setLevel(org.apache.logging.log4j.Level.ERROR);
               break;
           default:
               msg = "日志级别修改失败！";
               break;
       }
        ctx.updateLoggers();
        return msg;
    }
     
    /**
     * 查看现在包的日志级别
     * @return
     */
    @RequestMapping(value = "/loggers", method = RequestMethod.GET)
    public void index(HttpServletRequest request, HttpServletResponse response) {
         
        StringBuilder sb = new StringBuilder();
        try {
            sb.append("<html>");
            Writer writer = response.getWriter();
            response.setCharacterEncoding("UTF-8");
            response.setContentType("text/html; charset=utf-8");
            Logger logs = LogManager.getRootLogger();
            sb.append(logs.getName()+"  "+logs.getLevel());
            sb.append("</html>");
            writer.write(sb.toString());
            writer.flush();
            if(writer != null){
                writer.close();
            }
            System.out.println(sb.toString());
        } catch (Exception e) {
        }
         
    }
} 