package com.up.sell.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;
import java.util.HashSet;
import java.util.Set;
 
//参考：http://blog.csdn.net/catoop/article/details/50668896
@Configuration
@EnableSwagger2
public class Swagger2Config {
	@Value("${youpu.swagger.enabled:true}")
    Boolean swaggerEnabled;
 
    @Bean
    public Docket createRestApi() {
        //=====添加head参数start============================
        Set<String> consumes = new HashSet<>();
        consumes.add("application/x-www-form-urlencoded");
        Set<String> produces = new HashSet<>();
        produces.add("application/json;charset=UTF-8");
        
        return new Docket(DocumentationType.SWAGGER_2)
                //是否开启
                .enable(swaggerEnabled).select()
                .apis(RequestHandlerSelectors.basePackage("com.up.sell.controller.api"))
                .paths(PathSelectors.any())
                .build()
                .consumes(consumes)
                .produces(produces)
                .apiInfo(apiInfo());
    }
 
    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("Spring Boot使用 Swagger2 构建RestFul API")
                //版本号
                .version("1.0")
                //描述
                .description("CBMLS系统动态创建房源表接口")
                .build();
    }
 
}