/**
 * 
 */
package com.up.sell.config;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.format.FormatterRegistry;
import org.springframework.format.datetime.DateFormatter;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurationSupport;

import com.up.sell.interceptor.LoginInteceptor;
import com.up.sell.util.SpringObjectMapper;

/**
 * @author Administrator
 *
 */
@Configuration
public class WebMvcConfig extends WebMvcConfigurationSupport {
	private static final String[] EXCLUDE_PATTERNS = {"/resources/**"};
	@Autowired
	private LoginInteceptor loginInteceptor;
	@Override
	public void addInterceptors(InterceptorRegistry registry) {
		registry.addInterceptor(loginInteceptor)
		.addPathPatterns("/**")
		.excludePathPatterns(EXCLUDE_PATTERNS);
	}
	
	@Override
	protected void addFormatters(FormatterRegistry registry) {
		registry.addFormatter(new DateFormatter("yyyy-MM-dd HH:mm:ss"));
		registry.addFormatter(new DateFormatter("yyyy-MM-dd"));
	}

	@Override
	protected void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
        converters.add(new MappingJackson2HttpMessageConverter(new SpringObjectMapper()));
	}
	
	@Override
	 public void addResourceHandlers(ResourceHandlerRegistry registry) {
	 registry.addResourceHandler("/**").addResourceLocations("classpath:/static/");
	 registry.addResourceHandler("swagger-ui.html")
	 .addResourceLocations("classpath:/META-INF/resources/");
	 registry.addResourceHandler("/webjars/**")
	 .addResourceLocations("classpath:/META-INF/resources/webjars/");
	 }

}
