package com.up.sell.controller.api;

import java.io.IOException;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.http.HttpStatus;
import org.codehaus.jackson.JsonGenerationException;
import org.codehaus.jackson.map.JsonMappingException;
import org.codehaus.jackson.map.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.google.common.collect.Maps;
import com.up.sell.config.AliyunOssConfig;

@Controller
@RequestMapping("/oss")
public class AliOssUploadController {
	private static final Logger log = LoggerFactory.getLogger(AliOssUploadController.class);
	@Autowired
	HttpServletRequest request;
	@Autowired
	HttpServletResponse response;

	@Autowired
	AliyunOssConfig aliyunOssConfig;

	@RequestMapping("/policy")
	public @ResponseBody Map<String, String> getSign() {
		return aliyunOssConfig.getSig(aliyunOssConfig.getBucket(), aliyunOssConfig.getEndpoint(),
				aliyunOssConfig.getAccessId(), aliyunOssConfig.getAccessKey(), aliyunOssConfig.getDir());
	}

	@PostMapping("/callBack")
	public @ResponseBody Map<String, String> getCallBack()
			throws JsonGenerationException, JsonMappingException, IOException {
		String fileName = request.getParameter("filename");
		String size = request.getParameter("size");
		String mimeType = request.getParameter("mimeType");
		Map<String, String> map = Maps.newHashMap();
		map.put("fileName", fileName);
		map.put("size", size);
		map.put("mimeType", mimeType);
		log.info(new ObjectMapper().writeValueAsString(map));
		response.setStatus(HttpServletResponse.SC_OK);
		return map;
	}

	@GetMapping("/delObject")
	public @ResponseBody Map<?, ?> delObject(String objectKey) {
		Map<String, Object> map = Maps.newHashMap();
		try {
			OSS ossClient = new OSSClientBuilder().build(aliyunOssConfig.getEndpoint(), aliyunOssConfig.getAccessId(),
					aliyunOssConfig.getAccessKey());
			boolean found = ossClient.doesObjectExist(aliyunOssConfig.getBucket(), objectKey);
			if (found) {
				ossClient.deleteObject(aliyunOssConfig.getBucket(), objectKey);
			}
			ossClient.shutdown();
			map.put("code", HttpStatus.SC_OK);
		} catch (Exception e) {
			map.put("code", HttpStatus.SC_INTERNAL_SERVER_ERROR);
		}
		return map;
	}
}
