/**
 * 
 */
package com.up.sell.controller.api;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.up.sell.controller.AbstractController;
import com.up.sell.service.DictionaryService;
import com.up.sell.util.Constant;
import com.up.sell.util.ResultException;
import com.up.sell.vo.ResultObject;

import io.swagger.annotations.ApiOperation;

/**
 * @author zmg
 *
 */
@RestController
@RequestMapping(value = "/dictionary")
public class DictionaryController extends AbstractController {
	private static final Logger logger = LoggerFactory.getLogger(DictionaryController.class);

	@Autowired
	private DictionaryService dictionaryService;
	
	@PostMapping("/list/{parentKey}")
	public ResultObject projectList(HttpServletRequest request,@PathVariable(name="parentKey" ,required=true) String parentKey) {
		ResultObject resultObject = new ResultObject();
		try {
			resultObject.put("data", dictionaryService.selectMapByParentKey(parentKey));
		} catch (ResultException e) {
			resultObject.setCode(e.getCode());
			resultObject.setMessage(e.getMessage());
			logger.error(e.getMessage(), e);
		} catch (Exception e) {
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("系统异常");
			logger.error(e.getMessage(), e);
		}
		return resultObject;
    }
	
	@ApiOperation(value="获取项目业态list接口",httpMethod = "POST")
	@PostMapping("/getBusinessList")
	public ResultObject getBusinessList(HttpServletRequest request) {
		ResultObject resultObject = new ResultObject();
		try {
			String parentKey = "136";
			resultObject.put("data", dictionaryService.findByParentKey(parentKey));
		} catch (ResultException e) {
			resultObject.setCode(e.getCode());
			resultObject.setMessage(e.getMessage());
			logger.error(e.getMessage(), e);
		} catch (Exception e) {
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("系统异常");
			logger.error(e.getMessage(), e);
		}
		return resultObject;
	}
}
