package com.up.sell.controller.api;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;
import java.util.Objects;
import java.util.SortedMap;
import java.util.TreeMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.codec.binary.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.google.common.collect.Maps;
import com.up.sell.mapper.MemberMapper;
import com.up.sell.mapper.MemberOrderMapper;
import com.up.sell.util.DateUtils;
import com.up.sell.util.RequestXML2Map;
import com.up.sell.util.WxPayUtil;
import com.up.sell.vo.Member;
import com.up.sell.vo.MemberOrder;



@CrossOrigin
@RestController("appWXPayCallBackApi")
@RequestMapping("WXPayCallBackApi")
public class WXPayCallBackApi {
	
	private static final Logger log = LoggerFactory.getLogger(WXPayCallBackApi.class);
	public final static String API_KEY = "UoHcOi9L94MGAK3CsgAvhTUdJqesEbwo";//API密钥
	@Autowired
	private MemberOrderMapper memberOrderMapper;
	
	@Autowired
	private MemberMapper memberMapper;

	//支付回调函数
	@RequestMapping(value="callBack")
  	public void callBack(HttpServletRequest request,HttpServletResponse response,Model model) throws IOException {
  		log.info("WXPayCallBack  callback   run....");
  		try {
			// 1、获取支付回调参数 将支付回调参数解析为map形式
			Map<String, String> requestMap = RequestXML2Map.parseXml(request);
//			{transaction_id=4200000202201810131876249351, 
//			        nonce_str=300ecf93b7224cf439b6de6ee1d6c200, 
//					bank_type=CFT, 
//					openid=o407CwhMJ90WhR0-9fKFU-1E-97o, 
//					sign=2A887EE4632E745E8CF09FA7DC0C4D16, 
//					fee_type=CNY, 
//			        mch_id=1491974392, 
//					cash_fee=1, 
//					out_trade_no=20181013152822172083, 
//					appid=wx06e4787ad5a187a7, 
//					total_fee=1, 
//					trade_type=JSAPI, 
//					result_code=SUCCESS, 
//					time_end=20181013152911, 
//					is_subscribe=N, 
//					return_code=SUCCESS}
			log.info("result_code:" + requestMap.get("result_code")+"   "+"openid:" + requestMap.get("openid")+" out_trade_no : "+requestMap.get("out_trade_no"));
			// 过滤空 设置 TreeMap
			SortedMap<Object, Object> packageParams = new TreeMap<Object, Object>();
			Iterator it = requestMap.keySet().iterator();
			while (it.hasNext()) {
				String parameter = (String) it.next();
				String parameterValue = requestMap.get(parameter);
				String v = "";
				if (null != parameterValue) {
					v = parameterValue.trim();
				}
				packageParams.put(parameter, v);
			} 
			//添加付款日志记录
			String orderNo = (String) requestMap.get("out_trade_no");
			String time_end = (String) requestMap.get("time_end");
			String openid = (String) requestMap.get("openid");
//  			 2、校验支付回调签名是否正确     记录交易返回日志 TODO
  			if(WxPayUtil.isWxSing("UTF-8", packageParams, API_KEY)){
	  			if (requestMap.get("result_code").toString().equalsIgnoreCase("SUCCESS")) {
//	  			    3-1、校验成功  对数据库进行业务操作
	  				response.getWriter().write(WxPayUtil.setXML("SUCCESS", "")); 
	  				log.info("-------------"+WxPayUtil.setXML("SUCCESS", ""));
	  				String total_fee = (String)requestMap.get("total_fee");
	  				String transaction_id = (String)requestMap.get("transaction_id");
	  				log.info(" out_trade_no  ："+orderNo+"   "+" total_fee  ："+total_fee);
	  				MemberOrder order = memberOrderMapper.selectByPrimaryKey(orderNo);
	  				Integer memberId = order.getMemberId();
//  					//支付成功 更新对应记录
					Map<String, Object> map = Maps.newHashMap();
					map.put("memberId", memberId);
					MemberOrder memberOrder = memberOrderMapper.selectMemberOrder(map);
					if(Objects.nonNull(memberOrder)) {
						memberOrder.setServiceFlag(0);
						memberOrderMapper.updateByPrimaryKeySelective(memberOrder);	
					}
					order.setBeginTime(new Date());//服务开始日期
					if(StringUtils.equals("普通会员", order.getGoodsName())) {
						order.setEndTime(getEndDate(new Date(),"1"));//服务结束日期
					}else {
						order.setEndTime(getEndDate(new Date(),"2"));//服务结束日期
					}
						order.setBuyerEmail(openid);
					    order.setOrderStatus(2);
						order.setServiceFlag(1);//服务是否可用：1可用，0不可用，支付成功时设为可用
						order.setPayTime(DateUtils.format(time_end, "yyyyMMddHHmmss"));//支付时间
						order.setTradeNo(transaction_id);//支付流水号
						memberOrderMapper.updateByPrimaryKey(order);
						//更新用户表查看次数
						Member m = memberMapper.selectByPrimaryKey(order.getMemberId());
						Member me = new Member();
						me.setId(memberId);
						me.setViewCount(m.getViewCount()+order.getViewCount());
						memberMapper.updateByPrimaryKeySelective(me);
	  			  }else{
	  				  log.info("支付失败-------result_code为failed");
	  			  }
  			}else{
//  			3-2、签名校验失败 向微信服务器返回校验失败信息
  				log.info("支付失败-------回调签名验证失败！");
  				// msgMap.put("message", "校验失败，非法交易!");
  				response.getWriter().write(WxPayUtil.setXML("FAIL", ""));
  			}
  		} catch (Exception e) {
  			e.printStackTrace();
  		}
  	}
		
	//将订单金额由‘元’转成‘分’
	public String dollarToPenny(BigDecimal fee) {
		float sessionmoney = Float.parseFloat(fee.toString());  //amount.toString()
  		String finalmoney = String.format("%.2f", sessionmoney);
  		finalmoney = finalmoney.replace(".", "");
  		int intMoney = Integer.parseInt(finalmoney);
  		return String.valueOf(intMoney);
	}
	
	/**
	 * 获取服务结束日期
	 * @param date
	 * @param type
	 * @return
	 */
	public static Date getEndDate(Date date,String type) {
		Calendar calendar = Calendar.getInstance();
		calendar.setTime(new Date());
		if(StringUtils.equals("1", type)) {
			calendar.add(Calendar.MONTH, 1);
			calendar.add(Calendar.DAY_OF_MONTH, -1);
			return calendar.getTime();
		}else {
			calendar.add(Calendar.YEAR, 1);
			calendar.add(Calendar.DAY_OF_YEAR, -1);
			return calendar.getTime();
		}
	}
}
