package com.up.sell.fourhundred;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.up.sell.util.HttpRequest;
import com.up.sell.util.ObjectMyUtils;
import com.up.sell.vo.fourhundred.Department;
import com.up.sell.vo.fourhundred.DeptDetail;
import com.up.sell.vo.fourhundred.ResultFour;
import com.up.sell.vo.fourhundred.UserA;
import com.up.sell.vo.fourhundred.ZuoXiInfo;

/**
 * 400来电小号对接
 * @author PJJ
 * 临时测试账号
	网址：www.400cx.com
	测试号：boss@4008916688
	密码：boss@4008916688
	外显号码：4008916688
 *  http://47.100.249.22/platform/iface/saveDept.do?num=4008916688&deptName=优铺测试&parentDeptId=4008916688&ivrKey=555555&isChild=0
 	
 	【正式账号】
 	用户：boss@4001981188
	密码：up@123456
	外显： 4001981188
 	固话：01059002466
 */
public class  FourCallClient {
	
	private static final Logger logger = LoggerFactory.getLogger(FourCallClient.class);
	
	//测试账号 start
	/*public static final String entName="boss@4008916688";
	public static final String entPwd="boss@4008916688";
	public static final String fourPhone="4008916688";*/
	//测试账号 end
	
	//正式账号 start
	public static final String entName="boss@4001981188";
	public static final String entPwd="up@123456";
	public static final String fourPhone="4001981188";
	//正式账号 end
	
	public static final String zuoXiPwd="qw123456";
	public static final String guPhone="01058793722";
	public static final String guDeptName="转卖铺宝客服中心";
	public static final String guGonghao="4001";
	public static final String deptPre="mpb";

	private String URL="http://47.100.249.22/platform/iface";
	private String method_saveDept="/saveDept.do";
	private String method_saveUserAgentBindIvr="/saveUserAgentBindIvr.do";
	private String method_delAgent="/delAgent.do";  
	private String method_getAgentList="/getAgentList.do"; 
	private String method_getIvrInfo="/getIvrInfo.do"; 
	private String method_delDept="/delDept.do"; 
	private String method_getIvrTree="/getIvrTree.do"; 
	private String method_deleteUserAgent="/deleteUserAgent.do"; 
	private String method_getMaxReportNum="/getMaxReportNum.do"; 
	private String method_getUserAgentList="/getUserAgentList.do"; 
	private String method_getDeptDetail="/getDeptDetail.do"; 
	private String method_delUserAgent="/delUserAgent.do";
	private String method_getUserAgent="/getUserAgent.do"; 
	
	
	
	//保存新增导航
	public ResultFour saveDept(String ivrKey){
		ResultFour resultFour=new ResultFour();
		String deptName=deptPre+"["+ivrKey+"]导航";
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		if("0".equals(ivrKey)){
			params.put("deptName", guDeptName);
		}else{
			params.put("deptName", deptName);//导航名称（不能为空）
		}
		params.put("parentDeptId",fourPhone);//上级导航id（如果是400号码根导航下面新增时，只需填写400号码即可）
		params.put("ivrKey", ivrKey);//导航按键数（为按键进入导航方式设置，同一层导航按键数不能重复，按键数长度需和上级导航设置的按键长度一致）
		params.put("isChild", "0");//是否有下级导航，0为无，1为有
		//params.put("colorRingLsh", "");//导航彩铃流水号
		//params.put("childKeyLen", "");//下级导航导航按键长度范围1-7位
		//params.put("childinType", "");//进入下级导航方式，0位按键进入，1为分流进入
		//params.put("salesAlerttoneLsh", "");//坐席提示音流水号（无下级导航设置可用）
		String  postResult=HttpRequest.sendPost(URL+method_saveDept, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		resultFour=JSONObject.parseObject(postResult, ResultFour.class);
		if(res !=null && "true".equals(res.get("result")+"") && StringUtils.isNotEmpty(res.get("data")+"")){
			String deptId= JSONObject.parseObject(res.get("data")+"").get("deptId").toString();
			resultFour.setDeptId(deptId);
			resultFour.setDeptName(params.get("deptName"));
		}
		return resultFour;
	}

	
	/**
	 * 导航上新增坐席
	 * @param gongHao 坐席工号(2001-999999内数字)
	 * @param zuoXiName
	 * @param linkPhone
	 * @param deptId
	 *  工号和坐席名称不能重复，工号如果已经创建过，则把agentId拿过来直接绑定，不能重复创建
	 * @return
	 */
	public ResultFour saveUserAgentBindIvr(String linkPhone,String deptId){
		//获取最大一个工号新增
		String gongHao=this.getMaxReportNum();
		String gongHaoName=deptPre+"["+gongHao+"]坐席";
		ResultFour resultFour=new ResultFour();
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("deptId",deptId);//导航id
		if(guPhone.equals(linkPhone)){
			params.put("reportNum", guGonghao);
			params.put("userName", guDeptName);
		}else{
			params.put("reportNum", gongHao);//坐席工号(2001-999999内数字)
			params.put("userName", gongHaoName);//坐席名称(32个以内中英文、数字字符)
		}
		params.put("password", zuoXiPwd);//坐席密码
		params.put("bindPhone", linkPhone);//绑定号码(11--15位电话号码)
		params.put("agentType", "1");//坐席类型,0为外呼坐席，1为接听坐席，01两者皆是（如果为01中间以英文逗号分隔）
		String postResult=HttpRequest.sendPost(URL+method_saveUserAgentBindIvr,ObjectMyUtils.jsonParamMapToStr(params));
		resultFour=JSONObject.parseObject(postResult, ResultFour.class);
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("data")+"")) {
			String agentId= JSONObject.parseObject(res.get("data")+"").get("agentId").toString();
			resultFour.setAgentId(agentId);
			resultFour.setGongHaoName(params.get("userName"));
			resultFour.setGongHaoPwd(params.get("password"));
			resultFour.setFourPhone(params.get("num"));
			resultFour.setGongHao(params.get("reportNum"));
		}
		return resultFour;
	}
	
	
	/**
	 * 导航上新增坐席，绑定已有的坐席
	 * @param linkPhone
	 * @param deptId
	 * @return
	 */
	public Boolean saveSelectedAgentIds(String deptId,String selectedAgentIds){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("deptId",deptId);
		params.put("passwd",entPwd);
		//坐席id从已有坐席中选择当前导航不存在的坐席添加到当前导航，多个坐席id之间以逗号分隔，(必填字段只需num和deptId即可)，如果是新增坐席是该字段设置为空即可
		params.put("selectedAgentIds",selectedAgentIds);
		String postResult=HttpRequest.sendPost(URL+method_saveUserAgentBindIvr,ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "") ) {
			return true;
		}
		return false;
	}
	
	

	//只移除坐席，不移除用户
	public Boolean delOnlyAgent(String deptId,String agentId){
		if(deptId==null || agentId==null){
			logger.info("【删除部门("+deptId+")上的坐席("+agentId+")失败，参数有误！】");
			return false;
		}
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("deptId", deptId);//导航id
		params.put("agentId", agentId);//坐席id
		params.put("removeAll", "1");//值为1时同时取消接听权限（该坐席将会从所有导航中移除）
		String postResult=HttpRequest.sendPost(URL+method_delAgent,ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "")) {
			return true;
		}
		return false;
	}
	
	//15．删除导航
	public Boolean delDept(String deptId){
		DeptDetail  deptEntity=this.getDeptDetailById(deptId);
		if(deptEntity !=null && guDeptName.equals(deptEntity.getDeptName())){
			System.out.println("警告：不可以删除固话绑定的导航！");
			return false;
		}
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("deptId", deptId);//导航id
		String postResult=HttpRequest.sendPost(URL+method_delDept,ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "")) {
			return true;
		}
		return false;
	}
	
	
	//2．获取某个导航的坐席列表
	public List<ZuoXiInfo> getAgentList(String deptId){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		if(StringUtils.isNotEmpty(deptId)){
			params.put("deptId", deptId);//导航id
		}
		String postResult=HttpRequest.sendPost(URL+method_getAgentList,ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "")) {
			List<ZuoXiInfo> list= JSON.parseArray(res.get("data")+"", ZuoXiInfo.class);
			return list;
		}
		return null;
	}
	
	
	//获取导航信息根据导航名称
	public ResultFour getIvrEntityByDeptName(String deptName){
		ResultFour resultFour=new ResultFour();
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("ivrName", deptName);//导航名称（不能为空）
		String  postResult=HttpRequest.sendPost(URL+method_getIvrInfo, ObjectMyUtils.jsonParamMapToStr(params));
		resultFour=JSONObject.parseObject(postResult, ResultFour.class);
		JSONObject res = JSONObject.parseObject(postResult);
		if (res != null && "true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("data")+"")) {
			String deptId= JSONObject.parseObject(res.get("data")+"").get("deptId").toString();
			resultFour.setDeptId(deptId);
		}
		return resultFour;
	}
	
	
	//1．获取导航树
	public List<Department> getIvrTree(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		String  postResult=HttpRequest.sendPost(URL+method_getIvrTree, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("data")+"")) {
			List<Object> listO=JSON.parseArray(res.get("data")+"");
			if(listO==null || listO.size()==0){
				return null;
			}
			JSONObject tempJson=JSONObject.parseObject(listO.get(0)+"");
			String childrenStr=tempJson.get("children")+"";
			List<Department> listD= JSON.parseArray(childrenStr, Department.class);
			if(listD !=null && listD.size()>0){
				for(Department temp:listD){
					List<ZuoXiInfo>  zxList=this.getAgentList(temp.getId());
					if(zxList !=null && zxList.size()>0){
						temp.setZxList(zxList);
					}
				}
			}
			return listD;
		}
		return null;
	}
	
	
	
	
	//41．移除绑定在所有部门下的坐席后删除用户及坐席
	public Boolean delUserByAgentId(String sktAgentId){
		//不能删除固话
		String agentIdGu=this.findGuAgentId();
		if(agentIdGu !=null && sktAgentId.equals(agentIdGu)){
			logger.info("【不可删除固话坐席，delUserByAgentId（）方法提醒！】");
			return false;
		}
		//其他
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("agentId", sktAgentId);
		String  postResult=HttpRequest.sendPost(URL+method_deleteUserAgent, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			logger.info("【成功删除用户["+sktAgentId+"]】");
			return true;
		}
		return false;
	}
	
	//删除用户及坐席(根据用户id删)
	public Boolean delUserByUserId(String userId){
		String userIdGu=findGuUserId();
		if(userIdGu !=null && userId.equals(userIdGu)){
			logger.info("【不可删除固话用户，delUserByUserId（）方法提醒！】");
			return false;
		}
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);
		params.put("passwd",entPwd);
		params.put("userId", userId);
		String  postResult=HttpRequest.sendPost(URL+method_delUserAgent, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			logger.info("【成功删除用户ID为["+userId+"]的用户，和与他对应的坐席】");
			return true;
		}
		return false;
	}
	
	//29．获取最大坐席工号
	public String getMaxReportNum(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		String  postResult=HttpRequest.sendPost(URL+method_getMaxReportNum, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			String maxReportNum= JSONObject.parseObject(res.get("data")+"").get("maxReportNum").toString();
			return maxReportNum;
		}
		return null;
	}
	
	
	/**
	 * 根据部门id查询部门对象
	 * @param deptId
	 * @return
	 */
	public DeptDetail getDeptDetailById(String deptId){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("deptId", deptId);
		String  postResult=HttpRequest.sendPost(URL+method_getDeptDetail, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			DeptDetail   deptEn=JSON.parseObject(res.get("data")+"", DeptDetail.class);
			return deptEn;
		}
		return null;
	}
	
	//根据绑定的手机号反查坐席对象
	public UserA findUserEntityByPhone(String linkPhone){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("agentType","2");//查询坐席类型，2为全部，0为外呼坐席，1为接听坐席，-1为非坐席
		params.put("searchKeyWordType","bindPhoneNo");//检索条件关键字类型，userName为姓名，userCode为工号，bindPhoneNo为绑定号码
		params.put("searchKeyWordValue",linkPhone);//检索条件关键字值
		params.put("numPerPage","10");//没有查询条数，默认10条
		params.put("currentPage","1");//当前第几页
		String  postResult=HttpRequest.sendPost(URL+method_getUserAgentList, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			String userList= JSONObject.parseObject(res.get("data")+"").get("userList").toString();
			List<UserA> list= JSON.parseArray(userList, UserA.class);
			if(list !=null && list.size()>0){
				UserA user=list.get(0);
				return user;
			}
		}
		return null;
	}
	
	
	//清除所有的坐席和用户
	public void cleanAllUser(){
		List<UserA> listU=this.findUserList();
		if(listU !=null && listU.size()>0){
			for(UserA temp:listU){
				if( temp.getUserName().contains(deptPre) && !FourCallClient.guPhone.equals(temp.getBindPhoneNo())){
					//除了固话用户的mls前缀都可以删除
					this.delUserByUserId(temp.getUserId());
				}
			}
		}
	}
	
	
	//清空所有的导航坐席和用户（注意，执行完成以后需要清空表call_four_hundred）
	public void cleanAllDeptUser(){
		List<Department> list = this.getIvrTree();
		if (list != null && list.size() > 0) {
			for (Department temp : list) {
				//部门前缀包括“mls”并且不是固话，可以删
				if( temp.getText().contains(deptPre) && !FourCallClient.guDeptName.equals(temp.getText()) ){
					List<ZuoXiInfo> zxList = this.getAgentList(temp.getId());
					if(zxList !=null && zxList.size()>0){
						for(ZuoXiInfo zxTemp:zxList){
							//1)删除坐席+删除用户
							this.delUserByUserId(zxTemp.getUserId());
							//2)删除固话的坐席，不删除固话的用户
							this.delOnlyAgent(temp.getId(), this.findGuAgentId());
						}
					}
					//3)删除部门
					this.delDept(temp.getId());
				}
			}
		}
	}
	
	
	
	//获取坐席及用户列表
	public List<UserA> findUserList(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);//400号码
		params.put("passwd",entPwd);
		params.put("agentType","2");//查询坐席类型，2为全部，0为外呼坐席，1为接听坐席，-1为非坐席
		//params.put("searchKeyWordType","bindPhoneNo");//检索条件关键字类型，userName为姓名，userCode为工号，bindPhoneNo为绑定号码
		//params.put("searchKeyWordValue",linkPhone);//检索条件关键字值
		params.put("numPerPage","9999");//没有查询条数，默认10条
		params.put("currentPage","1");//当前第几页
		String  postResult=HttpRequest.sendPost(URL+method_getUserAgentList, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			String userList= JSONObject.parseObject(res.get("data")+"").get("userList").toString();
			List<UserA> list= JSON.parseArray(userList, UserA.class);
			if(list !=null && list.size()>0){
				return list;
			}
		}
		return null;
	}
	
	
	/**
	 * 根据userId找到坐席agentId
	 * 38．获取修改坐席数据
	 * @return
	 */
	public String getAgentIdByUserId(String userId){
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", fourPhone);
		params.put("passwd",entPwd);
		params.put("userId",userId);
		String  postResult=HttpRequest.sendPost(URL+method_getUserAgent, ObjectMyUtils.jsonParamMapToStr(params));
		JSONObject res = JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") ) {
			String userEn= JSONObject.parseObject(res.get("data")+"").get("user").toString();
			JSONObject jsonUser= JSONObject.parseObject(userEn);
			String agentId=jsonUser.get("agentId")+"";
			return agentId;
		}
		return null;
	}
	
	//查找固话用户id
	public String findGuUserId(){
		FourCallClient fc=new FourCallClient();
		UserA  userA=fc.findUserEntityByPhone(FourCallClient.guPhone);
		if(userA ==null){
			return null;
		}
		return userA.getUserId();
	}
	//查找固话坐席id
	public String findGuAgentId(){
		FourCallClient fc=new FourCallClient();
		UserA  userA=fc.findUserEntityByPhone(FourCallClient.guPhone);
		if(userA ==null){
			return null;
		}
		String  agentIdGu=fc.getAgentIdByUserId(userA.getUserId());
		if(StringUtils.isEmpty(agentIdGu)){
			return null;
		}
		return agentIdGu;
	}
	
	/**
	 * 每个导航下都绑定一个固话
	 */
	public void batchGuHuaToDept(){
		FourCallClient fc=new FourCallClient();
		List<Department> listDepart = fc.getIvrTree();
		if (listDepart ==null || listDepart.size()==0) {
			return;
		}
		String agentIdGu=fc.findGuAgentId();
		for (Department temp : listDepart) {
			String deptId=temp.getId();
			List<ZuoXiInfo> zxList = fc.getAgentList(deptId);
			//导航键下只绑定了一个坐席，且非固话坐席。
			if(zxList !=null && zxList.size()>0 && zxList.size()==1 
					&& !FourCallClient.guPhone.equals(zxList.get(0).getBindPhone())){
				//将固话绑定到每一个导航下面
				fc.saveSelectedAgentIds(deptId, agentIdGu);
				logger.info("【成功将固话("+FourCallClient.guPhone+")绑定到导航("+temp.getText()+")下面】");
			}
		}
	}
	
	//绑定固话
	/*public void initGuHuaPhone(){
		FourCallClient fc = new FourCallClient();
		ResultFour resultF=this.getIvrEntityByDeptName(FourCallClient.guDeptName);
		if(resultF==null){
			resultF=fc.saveDept("0");
		}
		if(StringUtils.isNotEmpty(resultF.getDeptId())){
			resultF=fc.saveUserAgentBindIvr(FourCallClient.guPhone,resultF.getDeptId());
			if("true".equals(resultF.getResult())){
				logger.info("=========【成功绑固话（" + FourCallClient.guPhone + "）】");
			}
			//将生成的固话绑定到每一个导航后面
			//fc.batchGuHuaToDept();
		}
	}*/
	
	
	
	
	public static void main(String[] args) {
		FourCallClient fc = new FourCallClient();
		fc.saveSelectedAgentIds("11681208725", "7879bb81-be73-4601-acf4-ebf00f2d63e8");
		
	}

}
