/*package com.up.zpb.fourhundred;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.up.zpb.pay.wx.HttpRequest;
import com.up.zpb.util.ObjectHelpUtils;
import com.up.zpb.vo.fourhundred.Answered;

public class  FourRecordClient {

	private String URL="http://47.100.249.22/platform/iface";
	private String method_answered="/answered.do";
	private String method_notAnswer="/notAnswer.do";
	private String method_voice="/voice.do";
	private String method_preciseTimeDetail="/preciseTimeDetail.do";
	private String method_getRecordFileUrl="/getRecordFileUrl.do";
	private String method_getBoxFileUrl="/getBoxFileUrl.do";
	
	//1．400已接电话
	public List<Answered> answeredList(String startTime,String endTime){
		Map<String, String> params=new HashMap<String, String>();
		params.put("name", FourCallClient.entName);//用户名
		params.put("passwd", FourCallClient.entPwd);//密码
		params.put("pageSize", "50");//每页返回条数（默认10条，最大可查询50条数据）
		params.put("pageNo", "1");//第几页
		params.put("num", FourCallClient.fourPhone);//400号码
		params.put("startTime", startTime==null?this.findStartOfDay(new Date()):startTime);//开始时间(只能查询当年数据)，格式为：2018-11-11
		params.put("endTime",endTime==null?this.findEndOfDay(new Date()):endTime);//结束时间(范围跨度为一个月内)，格式为：2018-12-11
		String postResult=HttpRequest.sendPost(URL+method_answered, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("data")+"")) {
			JSONObject  dataJson=JSONObject.parseObject(res.get("data")+"");
			List<Answered> listA= JSON.parseArray(dataJson.get("resultList")+"", Answered.class);
			return listA;
		}
		return null;
	}
	
	//2．400未接电话 
	public List<Answered> notAnswer(String startTime,String endTime,String pageNo){
		Map<String, String> params=new HashMap<String, String>();
		params.put("name", FourCallClient.entName);//用户名
		params.put("passwd", FourCallClient.entPwd);//密码
		params.put("pageSize", "50");//每页返回条数（默认10条，最大可查询50条数据）
		params.put("pageNo", pageNo==null?"1":pageNo);//第几页
		params.put("num", FourCallClient.fourPhone);//400号码
		params.put("startTime", startTime==null?this.findStartOfDay(new Date()):startTime);//开始时间(只能查询当年数据)，格式为：2018-11-11
		params.put("endTime",endTime==null?this.findEndOfDay(new Date()):endTime);//结束时间(范围跨度为
		String postResult=HttpRequest.sendPost(URL+method_notAnswer, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("data")+"")) {
			JSONObject  dataJson=JSONObject.parseObject(res.get("data")+"");
			List<Answered> listA= JSON.parseArray(dataJson.get("resultList")+"", Answered.class);
			return listA;
		}
		return null;
	}

	
	//3．语音信箱
	public JSONObject voice(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		String postResult=HttpRequest.sendPost(URL+method_voice, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		return res;
	}
	
	//4．400精确时间段清单查询（只限查一天内数据）
	public JSONObject preciseTimeDetail(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		String postResult=HttpRequest.sendPost(URL+method_preciseTimeDetail, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		return res;
	}
	
	*//**
	 * 获取录音下载路径URL
	 * @param lsh
	 * @param createDate  2019-12-27 15:05:15
	 * @return
	 * @throws ParseException 
	 *//*
	public String getRecordFileUrl(String lsh,String createDate) throws ParseException{
		Map<String, String> params=new HashMap<String, String>();
		params.put("num", FourCallClient.fourPhone);
		params.put("passwd", FourCallClient.entPwd);
		params.put("lsh", lsh);//通话流水号
		params.put("date",this.formatOnlyDayStr(createDate));//日期，该条记录的日期，格式为：2018-11-11 (yyyy-mm-dd), 2018-3-1格式不合法需改为 2018-03-01
		String postResult=HttpRequest.sendPost(URL+method_getRecordFileUrl, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		if ("true".equals(res.get("result") + "") && StringUtils.isNotEmpty(res.get("message")+"")) {
			String luying=res.get("message")+"";
			return luying;
		}
		return "";
	}
	
	
	//6．获取语音信箱下载路径URL
	public JSONObject getBoxFileUrl(){
		Map<String, String> params=new HashMap<String, String>();
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		params.put("xxx", "");//
		String postResult=HttpRequest.sendPost(URL+method_getBoxFileUrl, ObjectHelpUtils.jsonParamMapToStr(params));
		JSONObject  res=JSONObject.parseObject(postResult);
		return res;
	}
	
	public static String formatDateStr(Date currentTime) {
    	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
    	String dateString = formatter.format(currentTime);
    	return dateString;
    }
	
	// 获得某天最小时间 2019-08-27 00:00:00
    public static String findStartOfDay(Date date) {
    	 LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(date.getTime()), ZoneId.systemDefault());;
         LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
         Date dd= Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
    	return formatDateStr(dd);
    }
    // 获得某天最大时间 2019-08-27 23:59:59
    public static String findEndOfDay(Date date) {
    	LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(date.getTime()), ZoneId.systemDefault());;
        LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
        Date dd= Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
    	return formatDateStr(dd);
    	
    }
    
    
    //将2019-12-27 15:05:15 转换成2019-12-27 
    public String formatOnlyDayStr(String currentTime) throws ParseException{
    	Date dd = new SimpleDateFormat("yyyy-MM-dd").parse(currentTime);   
    	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
    	return formatter.format(dd);
    }
    
	
	public static void main(String[] args) throws ParseException {
		FourRecordClient fr=new FourRecordClient();
		//fr.answeredList(null,null);
	   //String resUrl=fr.getRecordFileUrl("ea27b917-4be7-4013-ad8f-a72a940b7008", "2019-12-27 15:05:15");
	   fr.notAnswer("2019-12-30", "2019-12-30","1");
	}
	
}
*/