package com.up.sell.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.up.sell.vo.Project;

public interface ProjectMapper {
    /**
     *
     * @mbg.generated 2018-09-05
     */
    int deleteByPrimaryKey(Integer id);

    /**
     *
     * @mbg.generated 2018-09-05
     */
    int insert(Project record);

    /**
     *
     * @mbg.generated 2018-09-05
     */
    int insertSelective(Project record);

    /**
     *
     * @mbg.generated 2018-09-05
     */
    Project selectByPrimaryKey(Integer id);

    /**
     *
     * @mbg.generated 2018-09-05
     */
    int updateByPrimaryKeySelective(Project record);

    /**
     *
     * @mbg.generated 2018-09-05
     */
    int updateByPrimaryKey(Project record);
    /**
     * 查询项目列表
     * @param parameters
     * cityId、projectType、houseType、beginPrice、endPrice、acreageRangeValue、districtId、projectName
     * @return
     */
    List<Map<String,Object>> selectProjectList(Map parameters);
    /**
     * 获取销售-商业详情页
     * @param projectId
     * @return
     */
    Map<String,Object> getProjectDetail1(@Param("projectId") Integer projectId,@Param("projectType") Integer projectType,@Param("houseType") Integer houseType,@Param("memberId") Integer memberId);
    /**
     * 获取销售-办公详情页
     * @param projectId
     * @param projectType
     * @param houseType
     * @return
     */
    Map<String,Object> getProjectDetail2(@Param("projectId") Integer projectId,@Param("projectType") Integer projectType,@Param("houseType") Integer houseType,@Param("memberId") Integer memberId);
    /**
     * 获取销售-住宅详情页
     * @param projectId
     * @param projectType
     * @param houseType
     * @return
     */
    Map<String,Object> getProjectDetail3(@Param("projectId") Integer projectId,@Param("projectType") Integer projectType,@Param("houseType") Integer houseType,@Param("memberId") Integer memberId);
   
    /**
     * 项目推荐
     * @param projectId
     * @param projectType
     * @param houseType
     * @param cityId 
     * @return
     */
    List<Map<String,Object>> projectRecommended(@Param("projectId") Integer projectId,@Param("projectType") Integer projectType,@Param("houseType") Integer houseType,@Param("cityId") Integer cityId);

    int updateViewCount(Integer id);
    
    List<Map<String,Object>> projectOnMap(Map parameters);
    /**
    * 首页项目列表
    * @param cityId
    * @param projectType
    * @return
    */
    List<Map<String,Object>> selectProjects(@Param("cityId") String cityId,@Param("projectType") Integer projectType,@Param("img") String img);
    /**
     * 我的发布
     * @param memberId
     * @return
     */
    List<Map<String,Object>> myPush(@Param("memberId") Integer memberId);
    /**
     * 业务首页项目列表
     * @param parameters
     * 	memberId、projectName
     * @return
     */
    List<Map<String,Object>> projectManagerProjectList(Map parameters);
    
    /**
     * 修改项目关注数
     * @param projectId
     * @return
     */
    int updateFavoriteCount(Map<String,Object> map);
    
    /**
     * 获取上架项目总数
     * @param map
     * @return
     */
    int selectProjectCount(Map<String,Object> map);
    
    /**
     * 查询项目列表分页总数
     * @param parameters
     * cityId、projectType、houseType、beginPrice、endPrice、acreageRangeValue、districtId、projectName
     * @return
     */
     int getProjectListCount(Map parameters);

     /**
      * 获取热门项目
      * @param parameters
      * @return
      */
	 List<Map<String, Object>> getRecommendProjectList(Map<String, Object> parameters);
	 
	 /**
	  * 获取咨询列表页火热项目
	  * @param parameters
	  * @return
	  */
	 List<Map<String, Object>> getHotProjectList(Map<String, Object> parameters);
}

