/**
 * 
 */
package com.up.sell.pay.wx;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.UUID;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.net.ssl.HttpsURLConnection;

import org.apache.commons.lang.StringUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.up.sell.util.ConfigurationUtils;
import com.up.sell.util.DateUtils;

/**
 * @author zhangmg
 *
 */
public class WxUtil {
	public final static String strUrl = ConfigurationUtils.getStringValue("downloadbill_url"); 
	public final static String appId = ConfigurationUtils.getStringValue("appId"); //微信公众号appid
	public final static String partnerKey = ConfigurationUtils.getStringValue("partnerKey");  //微信支付key
	public final static String partner = ConfigurationUtils.getStringValue("partner");//微信支付商户号

	public static List<BankStatement> getWxBill(Date date) throws IOException {
		List<BankStatement> bankStatementList = new ArrayList<BankStatement>();
		String noncestr = UUID.randomUUID().toString();
		SortedMap<String, String> params = new TreeMap<String, String>();
		params.put("appid", appId);
		params.put("mch_id", partner);
		params.put("nonce_str", noncestr);
		params.put("bill_date", DateUtils.format(date, "yyyyMMdd"));
		params.put("bill_type", "ALL");
		String sign = WxUtil.createSign(params,"UTF-8",partnerKey);
		params.put("sign", sign);
    	String doms = WxUtil.createXMLStr(params);
    	String str = WxUtil.readURL(strUrl, doms);
    	String newStr = str.replaceAll(",", " "); // 去空格
        String[] tempStr = newStr.split("`"); // 数据分组
        String[] t = tempStr[0].split(" ");// 分组标题
        int k = 1; // 纪录数组下标
        int j = tempStr.length / t.length; // 计算循环次数
        for (int i = 0; i < j; i++) {
        	BankStatement bankStatement = new BankStatement();
        	bankStatement.setPaymentType(1);
        	bankStatement.setTradingTime(DateUtils.format(tempStr[0 + k], "yyyy-MM-dd HH:mm:ss"));
        	bankStatement.setTradeNo(StringUtils.trim(tempStr[5 + k]));
        	bankStatement.setOrderNo(StringUtils.trim(tempStr[6 + k]));
        	bankStatement.setTradeStatus(StringUtils.trim(tempStr[9 + k]));
        	bankStatement.setBankType(StringUtils.trim(tempStr[10 + k]));
        	bankStatement.setFeeType(StringUtils.trim(tempStr[11 + k]));
        	bankStatement.setTotalFee(Double.valueOf(StringUtils.trim(tempStr[12 + k])));
        	bankStatement.setConsignmentFee(Double.valueOf(StringUtils.trim(tempStr[22 + k])));
        	if((i == j - 1) && (23 == t.length -1)){
        		String reg = "[\u4e00-\u9fa5]";//汉字的正则表达式
                Pattern pat = Pattern.compile(reg);  
                Matcher mat=pat.matcher(tempStr[23 + k]); 
                String repickStr = mat.replaceAll("");
        		bankStatement.setRate(Double.valueOf(StringUtils.remove(repickStr, "%"))/100);
        	} else{
        		bankStatement.setRate(Double.valueOf(StringUtils.remove(tempStr[23 + k], "%"))/100);
        	}
            /*for (int l = 0; l < t.length; l++) {
                *//*********************** 我添加的开始 ***********************//*
                //如果是最后列且是最后一行数据时，去除数据里的汉字
                if((i == j - 1) && (l == t.length -1)){
                    String reg = "[\u4e00-\u9fa5]";//汉字的正则表达式
                    Pattern pat = Pattern.compile(reg);  
                    Matcher mat=pat.matcher(tempStr[l + k]); 
                    String repickStr = mat.replaceAll("");
                    System.out.println(t[l] + ":" + repickStr);
                }else{
                    System.out.println(t[l] + ":" + tempStr[l + k]);
                }
                *//*********************** 我添加的结束 ***********************//*
            }*/
            k = k + t.length;
            bankStatementList.add(bankStatement);
        }
        return bankStatementList;
	}
	
	public static String readURL(String strUrl,String paramsDom) throws IOException {
		String result = null; 
		URL url = new URL(strUrl);
		HttpsURLConnection httpsURLConnection = (HttpsURLConnection) url.openConnection();
		httpsURLConnection.setDoInput(true);  
		httpsURLConnection.setDoOutput(true);
		httpsURLConnection.setRequestMethod("POST"); 
		httpsURLConnection.setRequestProperty("Content-Length",  
                String.valueOf(paramsDom.getBytes().length));  
		httpsURLConnection.setUseCaches(false);  
        //设置为gbk可以解决服务器接收时读取的数据中文乱码问题  
		httpsURLConnection.getOutputStream().write(paramsDom.getBytes("UTF-8"));  
		httpsURLConnection.getOutputStream().flush();  
		httpsURLConnection.getOutputStream().close();  
		int code = httpsURLConnection.getResponseCode(); 
		if (HttpsURLConnection.HTTP_OK == code){ 
			BufferedReader in = new BufferedReader(new InputStreamReader(httpsURLConnection.getInputStream())); 
			String temp = in.readLine(); 
			while (temp != null) {
				if (result != null) 
					result += temp; 
				else 
					result = temp;
				temp = in.readLine(); 
			}
		} 
		return result;
	}
	
	public static String createSign(SortedMap<String, String> packageParams,String charsetname,String key) {  
        StringBuffer sb = new StringBuffer();  
        Set<Entry<String, String>> es = packageParams.entrySet();  
        Iterator<Entry<String, String>> it = es.iterator();  
        while (it.hasNext()) {  
            Entry<String, String> entry = it.next();  
            String k = (String) entry.getKey();  
            String v = (String) entry.getValue();  
            if (null != v && !"".equals(v) && !"sign".equals(k)  
                    && !"key".equals(k)) {  
                sb.append(k + "=" + v + "&");  
            }  
        }  
        sb.append("key=").append(key);
        String sign = MD5Util.MD5Encode(sb.toString(),charsetname).toUpperCase();
        return sign;  
    }
	public static String createXMLStr(SortedMap<String, String> params) {
		Document document = XMLUtil.builder.newDocument();
    	Element root = document.createElement("xml");
    	for(Entry<String, String> entry : params.entrySet()) {
    		Element contentElement = document.createElement(entry.getKey());
			contentElement.setTextContent(entry.getValue());
			root.appendChild(contentElement);
    	}
    	document.appendChild(root);
    	return XMLUtil.toStringFromDoc(document);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
