package com.up.sell.service;

import java.util.List;
import java.util.Map;

import com.up.sell.vo.BrandContacts;
import com.up.sell.vo.BrandContactsError;
import com.up.sell.vo.BrandDatabase;
import com.up.sell.vo.ResultObject;

public interface BrandService {

	List<Map> getBrandBusinessList(boolean isAll);
	/**
	 * 查询品牌列表
	 * @param parameters
	 * 	cityId、brandName、areasId、regionsId、provinceId、brandBusiness
	 * @return
	 */
	List<Map> selectBrandList(Map parameters);
	
	public List<Map> selectBrandTopList(Map parameters);
	
	public void saveBrandDatabase(BrandDatabase brandDatabase);
	
	public Map selectBrandDetail(Integer id);
	
	public List<Map> selectBrandContacts(Integer id);
	
	public void createContact(BrandContacts brandContacts);
	
	public void createContactError(BrandContactsError brandContactsError);
	
	public ResultObject getBrandContact(Integer brandContactId,Integer memberId);
	
	/**
	 * 验证品牌名称是否重复
	 * @param parameters
	 * @return
	 */
	ResultObject valideBrandName(Map<String, Object> parameters);
	
	/**
	 * 获取热门品牌推荐列表
	 * @param parameters
	 * @return
	 */
	List<Map> getHotBrandList(Map<String, Object> parameters);
	
	/**
	 * 品牌详情页热门品牌推荐
	 * @param parameters
	 * @return
	 */
	List<Map<String,Object>> getBrandRecommended(Map<String, Object> parameters);
	
	/**
	 * 
	 * @param brandContactId
	 * @param id
	 * @return
	 */
	ResultObject getContactError(Integer brandContactsId, Integer memberId);
}