/**
 * 
 */
package com.up.sell.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.up.sell.annotation.Cacheable;
import com.up.sell.mapper.AreasMapper;
import com.up.sell.mapper.RegionsMapper;
import com.up.sell.mapper.SysCompanyMapper;
import com.up.sell.service.AreasService;

/**
 * @author zmg
 *
 */
@Service
@Transactional(propagation=Propagation.SUPPORTS)
public class AreasServiceImpl implements AreasService {

	@Autowired
	private AreasMapper areasMapper;
	@Autowired
	private RegionsMapper regionsMapper;
	
	@Autowired
	private SysCompanyMapper sysCompanyMapper;
	
	/* (non-Javadoc)
	 * @see com.up.sell.service.impl.AreasService#selectByParentId(java.lang.String)
	 */
	@Override
	@Cacheable(expireTime=60*60)
	public List<Map> selectByParentId(String parentid) {
		return areasMapper.selectByParentId(parentid);
	}
	
	/* (non-Javadoc)
	 * @see com.up.sell.service.impl.AreasService#selectBigAreas()
	 */
	@Override
	@Cacheable(expireTime=60*60)
	public List<Map> selectBigAreas() {
		List<Map> bigAreas = regionsMapper.selectAll();
		List<Map> areasList = areasMapper.selectBigAreas();
		for(Map regions : bigAreas) {
			for(int i=0;i<areasList.size();i++) {
				Map areas = areasList.get(i);
				if(StringUtils.equals(regions.get("id").toString(),areas.get("regions_id").toString())) {
					List<Map> aList = (List<Map>) regions.get("areasList");
					if(aList == null) {
						aList = new ArrayList<Map>();
						Map area2 = new HashMap<>();
						area2.put("area_name", "全部");
						area2.put("id", "");
						area2.put("regions_id", regions.get("id").toString());
						aList.add(area2);
					}
					areas.remove("regions_name");
//					areas.remove("regions_id");
					aList.add(areas);
					regions.put("areasList", aList);
					areasList.remove(i);
					i--;
				}
			}
		}
		return bigAreas;
	}

	@Override
	public List<Map<String,Object>> selectOpenedCities() {
		// TODO Auto-generated method stub
		return sysCompanyMapper.selectOpenedCities();
	}
}
