package com.up.sell.service.impl;

import java.util.Date;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.up.sell.mapper.MemberLoginLogMapper;
import com.up.sell.mapper.MemberRegisterLogMapper;
import com.up.sell.service.AsyncLoginLogService;
import com.up.sell.util.CodeGeneration;
import com.up.sell.util.IpAddressUtils;
import com.up.sell.vo.MemberLoginLog;
import com.up.sell.vo.MemberRegisterLog;

/** 
 * @author SJLv587
 * @version 2018年3月26日 上午11:20:41 
 */
@Service
@Transactional(propagation=Propagation.SUPPORTS)
public class AsyncLoginLogServiceImpl implements AsyncLoginLogService {
	
	private static final Logger logger = LoggerFactory.getLogger(AsyncLoginLogServiceImpl.class);
	
	@Autowired
	MemberLoginLogMapper memberLoginLogMapper;
	
	@Autowired
	MemberRegisterLogMapper memberRegisterLogMapper;
	
	@Async
	public void saveMemberLog(MemberLoginLog memberLoginLog) {
		try {
			Map<String, String> address = IpAddressUtils.getAddress(memberLoginLog.getIpAddress(), "UTF-8");
			String country = address.get("country");
			String countryId = address.get("countryId");
			String area = address.get("area");
			String areaId = address.get("areaId");
			String region = address.get("region");
			String regionId = address.get("regionId");
			String county1 = address.get("county1");
			String countyId1 = address.get("countyId1");
			String isp = address.get("isp");
			String ispId = address.get("ispId");
			memberLoginLog.setCreateTime(new Date());
			memberLoginLog.setId(CodeGeneration.getID());
			memberLoginLog.setCountry(country);
	        memberLoginLog.setCountryId(countryId);
			memberLoginLog.setArea(area);
			memberLoginLog.setAreaId(areaId);
			memberLoginLog.setRegion(region);
			memberLoginLog.setRegionId(regionId);
			memberLoginLog.setCountry(county1);
	        memberLoginLog.setCountryId(countyId1);
	        memberLoginLog.setIsp(isp);
	        memberLoginLog.setIspId(ispId);
			memberLoginLogMapper.insertSelective(memberLoginLog);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
		}
	}
	
	@Async
	public void saveMemberRegisterLog(MemberRegisterLog memberRegisterLog) {
		try {
			Map<String, String> address = IpAddressUtils.getAddress(memberRegisterLog.getIpAddress(), "UTF-8");
			String country = address.get("country");
			String countryId = address.get("countryId");
			String area = address.get("area");
			String areaId = address.get("areaId");
			String region = address.get("region");
			String regionId = address.get("regionId");
			String county1 = address.get("county1");
			String countyId1 = address.get("countyId1");
			String isp = address.get("isp");
			String ispId = address.get("ispId");
			memberRegisterLog.setCreateTime(new Date());
			memberRegisterLog.setCountry(country);
			memberRegisterLog.setCountryId(countryId);
			memberRegisterLog.setArea(area);
			memberRegisterLog.setAreaId(areaId);
			memberRegisterLog.setRegion(region);
			memberRegisterLog.setRegionId(regionId);
			memberRegisterLog.setCountry(county1);
			memberRegisterLog.setCountryId(countyId1);
			memberRegisterLog.setIsp(isp);
			memberRegisterLog.setIspId(ispId);
			memberRegisterLogMapper.insertSelective(memberRegisterLog);
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
		}
	}
}
