package com.up.sell.service.impl;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.google.common.collect.Maps;
import com.up.sell.annotation.Cacheable;
import com.up.sell.mapper.DictionaryMapper;
import com.up.sell.service.DictionaryService;
import com.up.sell.util.ConfigurationUtils;
import com.up.sell.vo.Dictionary;


@Service
@Transactional(propagation=Propagation.SUPPORTS)
public class DictionaryServiceImpl implements DictionaryService {

	@Autowired
	private DictionaryMapper dictionaryMapper;
	public final static String img_head = ConfigurationUtils.getStringValue("bank_img");

	@Cacheable(expireTime=60*60)
	public List<Map<String,Object>> selectMapByParentKey(String parentKey){
		return this.dictionaryMapper.selectMapByParentKey(parentKey);
	}

	@Override
	@Cacheable(expireTime=60*60)
	public List<Map<String, Object>> selectBankList(String parentKey) {
		// TODO Auto-generated method stub
		Map<String,Object> map = Maps.newHashMap();
		map.put("parentKey", parentKey);
		map.put("img", img_head);
		return dictionaryMapper.selectBankList(map);
	}
	
	@Override
	public List<Dictionary> findByParentKey(String parentKey) {
		return dictionaryMapper.selectByParentKey(parentKey);
	}
}
