/**
 * 
 */
package com.up.sell.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.up.sell.mapper.BrandDatabaseMapper;
import com.up.sell.mapper.InformationChannelMapper;
import com.up.sell.mapper.ProjectMapper;
import com.up.sell.service.InformationChannelService;
import com.up.sell.util.ConfigurationUtils;
import com.up.sell.util.Constant;

/**
 * @author zmg
 *
 */
@Service
@Transactional(propagation=Propagation.SUPPORTS)
public class InformationChannelServiceImpl implements InformationChannelService {

	@Autowired
	private InformationChannelMapper informationChannelMapper;
	
	@Autowired
	private ProjectMapper projectMapper;
	
	@Autowired
	private BrandDatabaseMapper brandDatabaseMapper;
	
	/* (non-Javadoc)
	 * @see com.up.sell.service.impl.InformationChannelService#selectInformationList(java.util.Map)
	 */
	@Override
	public List<Map> selectInformationList(Map parameters) {
		parameters.put("picDomain", ConfigurationUtils.getStringValue(Constant.PIC_DOMAIN));
		return this.informationChannelMapper.selectInformationList(parameters);
	}
	
	/* (non-Javadoc)
	 * @see com.up.sell.service.impl.InformationChannelService#selectInformationDetail(java.lang.Integer)
	 */
	@Override
	@Transactional(propagation=Propagation.REQUIRED)
	public Map selectInformationDetail(Integer id) {
		this.informationChannelMapper.updateReadingQuantity(id);
		Map<String, Object> parameters = new HashMap<String, Object>();
		parameters.put("picDomain", ConfigurationUtils.getStringValue(Constant.PIC_DOMAIN));
		parameters.put("id", id);
		return this.informationChannelMapper.selectInformationDetail(parameters);
	}

	@Override
	public List<Map<String, Object>> getHotProjectList(Map<String, Object> parameters) {
		parameters.put("picDomain", ConfigurationUtils.getStringValue(Constant.PIC_DOMAIN));		
		return projectMapper.getHotProjectList(parameters);
	}

	@Override
	public List<Map> getHotBrandList(Map<String, Object> parameters) {
		parameters.put("picDomain", ConfigurationUtils.getStringValue(Constant.PIC_DOMAIN));		
		return brandDatabaseMapper.getHotBrandList(parameters);
	}

	@Override
	public List<Map<String, Object>> selectInforList(Map<String, Object> parameters) {
		parameters.put("picDomain", ConfigurationUtils.getStringValue(Constant.PIC_DOMAIN));		
		return this.informationChannelMapper.selectInforList(parameters);
	}
}
