package com.up.sell.service.impl;

import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.sell.mapper.MemberOrderMapper;
import com.up.sell.mapper.MemberServiceMapper;
import com.up.sell.pay.wx.WxAuth;
import com.up.sell.pay.wx.WxPay;
import com.up.sell.service.WeChatPayService;
import com.up.sell.util.CodeGeneration;
import com.up.sell.util.IpAddressUtils;
import com.up.sell.util.ServletUtils;
import com.up.sell.vo.MemberOrder;
import com.up.sell.vo.MemberService;
import com.up.sell.vo.ResultObject;

@Service
public class WeChatPayServiceImpl implements WeChatPayService{
	
	@Autowired
	MemberServiceMapper memberServiceMapper;
	
	@Autowired
	MemberOrderMapper memberOrderMapper;
	
	/**
	 * 微信APP支付环境配置
	 */
	 //public final static String notifyUrl = "http://api.zpb.youpuchina.com/WXPayCallBackApi/callBack";
	 public final static String APPID = "wx7fe223bf9f6e4829";//服务号的应用号
	 public final static String MCH_ID = "1491974392";//商户号
	 public final static String API_KEY = "3e84b6613b6b35c2a6190ca5c15690c8";//API密钥
	 public final static String MCH_KEY = "UoHcOi9L94MGAK3CsgAvhTUdJqesEbwo";//API密钥
	 public final static String NOTIFY_URL = "http://api.youpuglobal.com/WXPayCallBackApi/callBack"; 
	//微信支付统一接口(POST)
	private static final String MP_APP_ID = "wx06e4787ad5a187a7";
	
	@Autowired
	AliPayServiceImpl aliPayServiceImpl;
	
	//1、创建订单
		public synchronized MemberOrder createOrder(Integer memberId,Integer orderSource,Integer id,Double payAmount) {
			MemberOrder mo = new MemberOrder();
			mo.setOrderNo(CodeGeneration.getOrderNo());//订单号
			mo.setMemberId(memberId);
			mo.setOrderSource(orderSource);
			mo.setOrderStatus(1);
			mo.setOrderType(1);
			mo.setPaymentType(1);//微信
			MemberService ms = memberServiceMapper.selectByPrimaryKey(id);
			mo.setGoodsId(id);
			mo.setViewCount(ms.getViewCount());
			mo.setCreateTime(new Date());
			mo.setPayAmount(payAmount);
			mo.setGoodsName(ms.getServiceName());
			memberOrderMapper.insertSelective(mo);
			return mo;
		}
		
		
	@Override
	public ResultObject h5WeChatPay(HttpServletRequest request) {
		ResultObject resultObject = new ResultObject();
		Map<String, Object> parameters = ServletUtils.getParameters(request);
		//处理参数
		Map<String, Object> map = aliPayServiceImpl.dealparameters(parameters);
		String orderNo = (String) map.get("orderNo");
		String subject = (String) map.get("subject");
		//String amount="0.01";
		Double payAmount = (Double) map.get("payAmount");
		//Double payAmount = Double.parseDouble(amount);
		String ip = parameters.get("ip").toString();
		try {
			String wxH5PayInfo = WxPay.getWxH5PayInfo(APPID, MCH_KEY, MCH_ID, orderNo, payAmount, NOTIFY_URL, ip);
			resultObject.put("data", wxH5PayInfo);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return resultObject;
	}

	@Override
	public ResultObject weChatPay(HttpServletRequest request) {
		ResultObject resultObject = new ResultObject();
		Map<String, Object> parameters = ServletUtils.getParameters(request);
		//处理参数
		Map<String, Object> map = aliPayServiceImpl.dealparameters(parameters);
		String orderNo = (String) map.get("orderNo");
		String subject = (String) map.get("subject");
		//String amount="0.01";
		Double payAmount = (Double) map.get("payAmount");
		//Double payAmount = Double.parseDouble(amount);
		String ip = IpAddressUtils.getIpAddress(request);
		String code = parameters.get("code").toString();
		Map<String, String> openID = WxAuth.getOpenID("wx06e4787ad5a187a7","25e4ff1fe6b8ade30c54f6c44b3c385b",code);
		String openid = openID.get("openid");
		try {
			 Map<String, Object> wxPayInfo = WxPay.getWxPayInfo(MP_APP_ID, MCH_KEY, MCH_ID, orderNo, payAmount, NOTIFY_URL, ip, openid);
			resultObject.put("data", wxPayInfo);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return resultObject;
	}

	@Override
	public ResultObject appWeChatPay(HttpServletRequest request) {
		ResultObject resultObject = new ResultObject();
		Map<String, Object> parameters = ServletUtils.getParameters(request);
		//处理参数
		Map<String, Object> map = aliPayServiceImpl.dealparameters(parameters);
		String orderNo = (String) map.get("orderNo");
		String subject = (String) map.get("subject");
		//String amount="0.01";
		Double payAmount = (Double) map.get("payAmount");
		//Double payAmount = Double.parseDouble(amount);
		String userIP =IpAddressUtils.getIpAddress(request);
		try {
			Map<String, Object> appWxPayInfo = WxPay.getAppWxPayInfo(APPID, MCH_KEY, MCH_ID, orderNo, payAmount, NOTIFY_URL, userIP);
			resultObject.put("data", appWxPayInfo);
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return resultObject;
	}

}
