/**
 * 
 */
package com.up.sell.util;

import java.text.ParseException;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.codec.binary.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSONObject;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsRequest;
import com.aliyuncs.dysmsapi.model.v20170525.SendSmsResponse;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.exceptions.ServerException;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;



/**
 * @author zhangmg
 *
 */
public class AliSMS {
	private static final Logger logger = LoggerFactory.getLogger(AliSMS.class);
	private static final String accessKeyId = "LTAIJkZwn1w4UBfK";//你的accessKeyId,参考本文档步骤2
	private static final String accessKeySecret = "VIALh1091NPyAuoCOtrCvgCxulZyq5";//你的accessKeySecret，参考本文档步骤2
	
	/**
	 * 使用同一个签名，对同一个手机号码发送短信验证码，1条/分钟，5条/小时，10条/天
	 * 发送短信验证码
	 * @param verificationCode	验证码
	 * @param mobiles	必填:待发送手机号。支持以逗号分隔的形式进行批量调用，批量上限为1000个手机号码,批量调用相对于单条调用及时性稍有延迟,验证码类型的短信推荐使用单条调用的方式
	 * @return
	 * @throws ServerException
	 * @throws ClientException
	 */
	public static Map<String,String> sendVerificationCode (String verificationCode,String mobiles,String type) {
		Map<String,String> result = new HashMap<String, String>();
		try {
			System.setProperty("sun.net.client.defaultConnectTimeout", "10000");
			System.setProperty("sun.net.client.defaultReadTimeout", "10000");
			//初始化ascClient需要的几个参数
			final String product = "Dysmsapi";//短信API产品名称（短信产品名固定，无需修改）
			final String domain = "dysmsapi.aliyuncs.com";//短信API产品域名（接口地址固定，无需修改）
			//替换成你的AK
			//初始化ascClient,暂时不支持多region
			IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", accessKeyId, accessKeySecret);
			DefaultProfile.addEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
			IAcsClient acsClient = new DefaultAcsClient(profile);
			 //组装请求对象
			 SendSmsRequest request = new SendSmsRequest();
			 //使用post提交
			 request.setMethod(MethodType.POST);
			 //必填:待发送手机号。支持以逗号分隔的形式进行批量调用，批量上限为1000个手机号码,批量调用相对于单条调用及时性稍有延迟,验证码类型的短信推荐使用单条调用的方式
			 request.setPhoneNumbers(mobiles);
			 //必填:短信签名-可在短信控制台中找到
			 request.setSignName("优铺");
			 //必填:短信模板-可在短信控制台中找到
			 if(StringUtils.equals("1", type)) {
				 request.setTemplateCode(Constant.LOGIN_SMS_TEMPLATE_CODE); 
			 }else {
				 request.setTemplateCode(Constant.CERTIFICATION_SMS_TEMPLATE_CODE);  
			 }
			 //可选:模板中的变量替换JSON串,如模板内容为"亲爱的${name},您的验证码为${code}"时,此处的值为
			 //友情提示:如果JSON中需要带换行符,请参照标准的JSON协议对换行符的要求,比如短信内容中包含\r\n的情况在JSON中需要表示成\\r\\n,否则会导致JSON在服务端解析失败
			 JSONObject json = new JSONObject();
			 json.put("code", verificationCode);
			 request.setTemplateParam(json.toString());
			 //可选-上行短信扩展码(无特殊需求用户请忽略此字段)
			 //request.setSmsUpExtendCode("90997");
			 //可选:outId为提供给业务方扩展字段,最终在短信回执消息中将此值带回给调用者
			 //request.setOutId("yourOutId");
			//请求失败这里会抛ClientException异常
			SendSmsResponse sendSmsResponse = acsClient.getAcsResponse(request);
			result.put("Code", sendSmsResponse.getCode());
			result.put("Message", sendSmsResponse.getMessage());
			result.put("RequestId", sendSmsResponse.getRequestId());
			result.put("BizId", sendSmsResponse.getBizId());
			result.put("mobiles", mobiles);
			result.put("content", verificationCode);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.error(e.getMessage(), e);
		} 
		return result;
	}
	
	/**
	 * @param args
	 * @throws ClientException 
	 * @throws ParseException 
	 */
	public static void main(String[] args) throws ClientException, ParseException {
      System.out.println(AliSMS.sendVerificationCode("123456", "13241871616","1"));
		 
	}

}
