package com.up.sell.util;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

public class CheckParametersUtil {

	 Map<String, Object> map = new HashMap<>();

	    /**
	     * 添加需要校验的参数
	     * @param object 实参
	     * @param parameterName 参数名称
	     * @return CheckParametersUtil
	     * @author: XuWei
	     */
	    public CheckParametersUtil put(Object object, String parameterName) {
	        map.put(parameterName, object);
	        return this;
	    }
	    /**
	     * 获取CheckParametersUtil实例
	     * @return CheckParametersUtil
	     * @author: XuWei
	     */
	    public static CheckParametersUtil getInstance(){
	        return new CheckParametersUtil();
	    }

	    /**
	     * 校验
	     * @return DataMessage
	     * @author: XuWei
	     * @throws Exception 
	     */
	    public void checkParameter() throws Exception {
	        for(Entry<String, Object> entry : map.entrySet()) {  
	          if(isEmpty(entry.getValue())){
	              throw new Exception("参数【" + entry.getKey() + "】为空" );
	          }
	        }  
	    }

	    public String toString(Object object) {
	        return object == null ? "" : object.toString();
	    }

	    public boolean isEmpty(Collection collection) {
	        return collection == null || collection.isEmpty();
	    }

	    public boolean isEmpty(Map map) {
	        return map == null || map.isEmpty();
	    }

	    public boolean isEmpty(String string) {
	        return toString(string).isEmpty();
	    }

	    public boolean isEmptyTrim(String string) {
	        return toString(string).trim().isEmpty();
	    }

	    public boolean isEmpty(Object object) {
	        return toString(object).isEmpty();
	    }

	    public boolean isEmptyTrim(Object object) {
	        return toString(object).trim().isEmpty();
	    }

	    public <T> boolean isEmpty(T[] array) {
	        return array == null || array.length == 0;
	    }
	    
	    public static void main(String[] args){
	    	try {
				CheckParametersUtil.getInstance()
				           .put(null, "loginUserId")//第一个位置放需要校验的参数,第二个位置放参数名称
				         .put("aa", "branId")
				      .put("", "shelfNo")
				          .checkParameter();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.out.println("111");
				
			}
	   
		}
}
