package com.up.sell.util;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.up.sell.service.chuangnan.ChuangNanService;

/**
 * 流程节点发送短信工具类
 */
public class ProcessSMSUtils {

	Logger logger = LoggerFactory.getLogger(ProcessSMSUtils.class);
    /**
     * 针对案场项目助理的提示
     *
     * @return
     */
    public String baobeiSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好：经纪人" + map.get("name") + "于" + map.get("startDate") + " 已报备" + map.get("projectName") + "，客户" + map.get("customerName") + "，电话为" + map.get("phone") + ";报备保护截至日期为" + map.get("endDate") + "。请做好客户报备审核；以免客户流失！";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }


    /**
     * 针对经纪人提示   报备审核成功
     *
     * @return
     */
    public String BaobeiSuccessSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好！您于" + map.get("startDate") + " 提交的客户" + map.get("customerName") + "在" + map.get("projectName") + "的带看报备已审核成功；保护截至日期为" + map.get("endDate") + "。请您尽快带看以免客户流失，项目经理" + map.get("manager") + " 电话：" + map.get("phone") + "。";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }

    /**
     * 针对经纪人提示   报备审核失败
     *
     * @return
     */
    public String BaobeiFailureSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好！您于" + map.get("startDate") + " 提交的客户" + map.get("customerName") + "在" + map.get("projectName") + "的带看报备审核失败；为避免客户流程，请尽快联系项目经理，项目经理" + map.get("manager") + " 电话：" + map.get("phone") + "。";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }

    /**
     * 针对经纪人提示   到访成功
     *
     * @return
     */
    public String DaofangSuccessSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好！恭喜您：您于" + map.get("startDate") + " 提交的客户" + map.get("customerName") + "在" + map.get("projectName") + "已确认到访；保护截至日期为" + map.get("endDate") + "。项目经理" + map.get("manager") + " 电话：" + map.get("phone") + "。";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }

    /**
     * 认购成功
     *
     * @param map
     * @return
     */
    public String RengouSuccessSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好！恭喜您：您于" + map.get("startDate") + " 提交的客户" + map.get("customerName") + "在" + map.get("projectName") + "已成功认购； 认购日期" + map.get("endDate") + ".认购详情请登录卖铺宝app进行查看。项目经理" + map.get("manager") + " 电话：" + map.get("phone") + "。";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }

    /**
     * 签约成功
     *
     * @param map
     * @return
     */
    public String QianyueSuccessSend(Map<String, Object> map,ChuangNanService chuangNanService) {
        String msg = "您好！恭喜您：您于" + map.get("startDate") + " 提交的客户" + map.get("customerName") + "在" + map.get("projectName") + "楼盘已成功签约；签约日期" + map.get("endDate") + "，签约详情请登录卖铺宝app进行查看，项目经理" + map.get("manager") + " 电话：" + map.get("phone") + "。";
        try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return msg;
    }
    
    /**
     * 团队成员进人团队提醒
     */
    public String joinTeamSuccessSend(Map<String, Object> map,ChuangNanService chuangNanService) {
    		String msg = map.get("userPhone")+"成功加入团队 '"+map.get("teamName")+"'";
    		try {
            chuangNanService.sendCnMsg(msg, map.get("sendPhone") + "");
        } catch (Exception e) {
            e.printStackTrace();
        }
    		return msg;
    }

}
