package com.up.sell.util;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;

import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSONObject;
import com.up.sell.vo.ResultObject;
import com.up.sell.vo.wxmsg.WechatTemplate;
/**
 * 【公众号】
 * 组装、发送模板消息
 * @author PJJ
 *
 */
public class WxPublicAccountSMSUtil{
	private static final Logger logger = LoggerFactory.getLogger(WxPublicAccountSMSUtil.class);
	//授权获得code连接：https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx06e4787ad5a187a7&redirect_uri=http%3a%2f%2fm.youpuglobal.com%2fhome&response_type=code&scope=snsapi_base&state=123#wechat_redirect

	//=========微信公众号开发基本配置 start============
	//微信公众号的wx_appid
	public final static String wx_appid="wx06e4787ad5a187a7";
	//微信公众号的wx_appsecret
	public final static String wx_appsecret="ac66fb86f03fb2cd2e2228f707b22b90";
	//微信公众号的token
	//public final static String wx_token="";
	//微信公众号的消息加解密密钥aeskey
	//public final static String wx_aeskey="";
	//=========微信公众号开发基本配置 end============

	//发送微信模板url
	private final String SEND_TEMPLATE_MESSAGE_URL = "https://api.weixin.qq.com/cgi-bin/message/template/send";
	//模板消息详情跳转URL
	private static String url = "http://m.youpuglobal.com/home";//卖铺宝m站首页链接
	//=========消息模板id配置   start============
	//针对案场项目助理的提示；
	//【卖铺宝】您好：XXX公司经纪人胡晓旭于2020-4-2 17:20 已报备XXX项目，客户X先生，电话为111-111;报备保护截至日期为2020-4-3 17:20。请做好客户报备审核；以免客户流失！
	//public final static String temp_id_baobei="H_mYP5Sjy8gnRZ6dOZaVZIqp8hl5TJe2RNowV_CUqj8";//报备新客户

	//针对经纪人提示   
	//[报备审核成功]您于2020-4-2 17:20 提交的客户X先生在XXX项目的带看报备已审核成功；保护截至日期为2020-4-3 17:20。请您尽快带看以免客户流失，项目经理xxx 电话：138.......。
	public final static String temp_id_audit_succ="mBs2afonGjnhZ-7BLCM0Njz0DDbiW1QV0fDlitzgzLI";

	/*//报备审核失败
	//【卖铺宝】您好！您于2020-4-2 17:20 提交的客户X先生在XXX项目的带看报备审核失败；为避免客户流程，请尽快联系项目经理，项目经理xxx 电话：138........
	public final static String temp_id_audit_fail="mBs2afonGjnhZ-7BLCM0Njz0DDbiW1QV0fDlitzgzLI";

	//到访成功
	//【卖铺宝】您好！恭喜您：您于2020-4-2 17:20 提交的客户X先生在XXX项目已确认到访；保护截至日期为2020-5-1  17:20。项目经理xxx 电话：138........
	public final static String temp_id_daofang="xxx";

	//认购成功
	//【卖铺宝】您好！恭喜您：您于2020-4-2 17:20 提交的客户X先生在XXX项目已成功认购； 认购日期2020-4-20 17:20.认购详情请登录卖铺宝app进行查看。项目经理xxx 电话：138........
	public final static String temp_id_rengou="xxx";

	//签约成功
	//【卖铺宝】您好！恭喜您：您于2020-4-2 17:20 提交的客户X先生在XXX楼盘已成功签约；签约日期2020-4-30 17:20，签约详情请登录卖铺宝app进行查看，项目经理xxx 电话：138........
	public final static String temp_id_qianyue="xxx";*/
	//=========消息模板id配置  end============



	public ResultObject testSendWxMsg(String code) {
		ResultObject resultObject = new ResultObject();
		//第一步：获取openId
		String access_token_url = "https://api.weixin.qq.com/sns/oauth2/access_token";
		String accessTokenObj = HttpRequest.sendGet(access_token_url, "appid=" + wx_appid + "&secret="
				+ wx_appsecret + "&code=" + code + "&grant_type=authorization_code");
		if("-1".equals(code)){
			accessTokenObj="{\"access_token\":\"33_KWCbQgZ7SPous5P4e8d3ijr0eAcjvnXnDxCIEzgQ3MsuC_-6eNLILhN3nsU8jt_GVXf8IrHuXXGe36xaptbYgA\",\"expires_in\":7200,\"refresh_token\":\"33_tFRkf8kKgILQXoazE2HryveFEbukBr8OzVWTeNcOGpArYL11BST4FP2u-L6KRAuM_CviKwqKlG9QiBlXJTIvpg\",\"openid\":\"o407CwqCMv1AOwJSnMH12PFaUakw\",\"scope\":\"snsapi_base\"}";
			//{"access_token":"33_KWCbQgZ7SPous5P4e8d3ijr0eAcjvnXnDxCIEzgQ3MsuC_-6eNLILhN3nsU8jt_GVXf8IrHuXXGe36xaptbYgA","expires_in":7200,"refresh_token":"33_tFRkf8kKgILQXoazE2HryveFEbukBr8OzVWTeNcOGpArYL11BST4FP2u-L6KRAuM_CviKwqKlG9QiBlXJTIvpg","openid":"o407CwqCMv1AOwJSnMH12PFaUakw","scope":"snsapi_base"}
		}
		logger.info("第一步：获取openId返回报文：", accessTokenObj);
		JSONObject jsonToken = JSONObject.parseObject(accessTokenObj);
		if("40029".equals(jsonToken.getString("errcode"))){
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("【code失效了，请重新生成一个】");
			logger.info("code失效了，请重新生成一个");
			return resultObject;
		}else if(StringUtils.isBlank(String.valueOf(jsonToken))){
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("【openid不能为空】");
			return resultObject;
		}
		String openId = jsonToken.getString("openid");

		//第三步：获取发送消息
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		params.put("first", WechatTemplate.item("消息提醒", "#000000"));
		params.put("keyword1", WechatTemplate.item("2020-05-19", "#000000"));
		params.put("keyword2", WechatTemplate.item("审核通过", "#000000"));
		params.put("remark", WechatTemplate.item("[报备审核成功]您于2020-05-18提交的客户小王在恒大名都项目的带看报备已审核成功", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_audit_succ);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);//这个连接表示点击这条消息跳转进去的页面
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();
		//
		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());//第二步:通过code换取网页授权access_token
		logger.info("向公众号发送消息入参为：", sendData);
		String resultObj = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("第三步：获取发送消息"+resultObj);//成功报文为：{"errcode":0,"errmsg":"ok","msgid":1346747294821187584}
		System.out.println("第三步：获取发送消息:"+resultObj);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		JSONObject JsonMsg = JSONObject.parseObject(resultObj);
		if(!"0".equals(JsonMsg.get("errcode")+"")){
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("【向用户openId（"+openId+"）发送公众号消息失败】");
			logger.info("【接口获取access_token失败！】");
		}
		return resultObject;
	}

	/**
	 * 网页授权获取openId  
	 * @Title: getOpenId
	 * @Description: TODO
	 * @param code
	 * @return JSONObject
	 */
	public ResultObject findOpenIdGzh(String code) {
		ResultObject resultObject = new ResultObject();
		try {
			//第一步：获取openId
			String access_token_url = "https://api.weixin.qq.com/sns/oauth2/access_token";
			String accessTokenObj = HttpRequest.sendGet(access_token_url, "appid=" + wx_appid + "&secret="
					+ wx_appsecret + "&code=" + code + "&grant_type=authorization_code");
			if("-1".equals(code)){
				accessTokenObj="{\"access_token\":\"33_KWCbQgZ7SPous5P4e8d3ijr0eAcjvnXnDxCIEzgQ3MsuC_-6eNLILhN3nsU8jt_GVXf8IrHuXXGe36xaptbYgA\",\"expires_in\":7200,\"refresh_token\":\"33_tFRkf8kKgILQXoazE2HryveFEbukBr8OzVWTeNcOGpArYL11BST4FP2u-L6KRAuM_CviKwqKlG9QiBlXJTIvpg\",\"openid\":\"o407CwqCMv1AOwJSnMH12PFaUakw\",\"scope\":\"snsapi_base\"}";
				//{"access_token":"33_KWCbQgZ7SPous5P4e8d3ijr0eAcjvnXnDxCIEzgQ3MsuC_-6eNLILhN3nsU8jt_GVXf8IrHuXXGe36xaptbYgA","expires_in":7200,"refresh_token":"33_tFRkf8kKgILQXoazE2HryveFEbukBr8OzVWTeNcOGpArYL11BST4FP2u-L6KRAuM_CviKwqKlG9QiBlXJTIvpg","openid":"o407CwqCMv1AOwJSnMH12PFaUakw","scope":"snsapi_base"}
			}
			logger.info("第一步：获取openId返回报文：", accessTokenObj);
			JSONObject jsonToken = JSONObject.parseObject(accessTokenObj);
			if("40029".equals(jsonToken.getString("errcode")) || "40163".equals(jsonToken.getString("errcode"))){
				resultObject.setCode(Constant.CODE_EXCEPTION);
				resultObject.setMessage("【code失效了，请重新生成一个】");
				logger.info("code失效了，请重新生成一个");
				return resultObject;
			}
			String openId=jsonToken.getString("openid");
			if(StringUtils.isEmpty(openId)){
				resultObject.setCode(Constant.CODE_EXCEPTION);
				resultObject.setMessage("获取oenid失败！报错信息为："+jsonToken);
				logger.info("获取oenid失败！报错信息为："+jsonToken);
				return resultObject;
			}
			logger.info("【===================成功获取openid为："+openId+"】");
			resultObject.put("openId", openId);
		} catch (Exception e) {
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("异常了");
			logger.error(e.getMessage(), e);
		}finally {
			logger.info("获取oenid最后返回结果："+resultObject);
		}
		return resultObject;
	}


	//第二步：获取 access_token
	public String getAccessToken(){
		String tokenObj = HttpRequest.sendGet("https://api.weixin.qq.com/cgi-bin/token", "grant_type=client_credential&appid="+wx_appid+"&secret="+wx_appsecret);
		JSONObject retToken = JSONObject.parseObject(tokenObj);
		String accessToken = String.valueOf(retToken.get("access_token"));
		logger.info("【调用微信平台获取 access_token方法失败，请检查（1）访问ip是否在公众号[安全中心]配置了白名单；(2)appid和secret秘钥是否正确，返回报文："+accessToken+"】");
		return accessToken;
		/*
			//由于access_token拥有较短的有效期，当access_token超时后，可以使用refresh_token进行刷新，refresh_token有效期为30天，当refresh_token失效之后，需要用户重新授权
			//String urlToken = "https://api.weixin.qq.com/cgi-bin/token";
			//String tokenObj = WxAppHttpUtil.doGet(urlToken, "grant_type=client_credential" + "&secret=" + wx_appsecret + "&wx_appid=" + wx_appid);
			resultObject.put("accessToken", accessToken);
			return resultObject;*/
	}


	



	/**
	 * //针对案场项目助理的提示；
			   //【卖铺宝】您好：经纪人{{name.DATA}}于 {{startDate.DATA}} 已报备{{projectName.DATA}}项目，客户{{customerName.DATA}}，电话为{{phone.DATA}};报备保护截至日期为{{endDate.DATA}}。请做好客户报备审核；以免客户流失！
	 * @param openId
	 * @return
	 * @throws Exception
	 *   {{name.DATA}}
				 {{startDate.DATA}}
				 {{projectName.DATA}}
				 {{customerName.DATA}}
				 {{phone.DATA}}
				 {{endDate.DATA}}
	 */
	/*public String sendWxMsg_BaoBei(Map<String, Object> map) throws Exception{
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("name", WechatTemplate.item("白开水", "#000000"));
		params.put("startDate", WechatTemplate.item(map.get("startDate")+"", "#000000"));
		params.put("projectName", WechatTemplate.item(map.get("projectName")+"", "#000000"));
		params.put("customerName", WechatTemplate.item(map.get("customerName")+"", "#000000"));
		params.put("phone", WechatTemplate.item(map.get("phone")+"", "#000000"));
		params.put("endDate", WechatTemplate.item(map.get("endDate")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_baobei);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("板参数组装{}", sendData);

		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String retInfo = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("消息模板返回{}", retInfo);
		System.out.println("消息模板返回报文:"+retInfo);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		return retInfo;
	}

	*//**
	 * //针对经纪人提示   
				//[报备审核成功]您于{{startDate.DATA}}提交的客户{{customerName.DATA}}在{{projectName.DATA}}项目的带看报备已审核成功；保护截至日期为{{endDate.DATA}}。请您尽快带看以免客户流失，项目经理{{manager.DATA}} 电话：{{phone.DATA}}。
	 * @param openId
	 * @return
	 *  {{startDate.DATA}}
				{{customerName.DATA}}
				{{projectName.DATA}}
				{{endDate.DATA}}
				{{manager.DATA}}
				{{phone.DATA}}
	 *//*
	public ResultObject sendWxMsg_AuditSucc(Map<String, Object> map)throws Exception {
		ResultObject resultObject=new ResultObject();
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("first",  WechatTemplate.item("您有新的消息提醒","#000000"));
		params.put("keyword1", WechatTemplate.item("2020-05-19", "#000000"));
		params.put("keyword2", WechatTemplate.item("消息提醒", "#000000"));
		params.put("remark", WechatTemplate.item(map.get("remark")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_audit_succ);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("【发送公众号消息-请求入参："+sendData);
		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String resultObj = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("【发送公众号消息-返回报文"+resultObj+"】");
		JSONObject JsonMsg = JSONObject.parseObject(resultObj);
		if(!"0".equals(JsonMsg.get("errcode")+"")){
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("【向用户openId（"+openId+"）发送公众号消息失败。返回报文"+JsonMsg+"】");
			logger.info("【向用户openId（"+openId+"）发送公众号消息失败。返回报文"+JsonMsg+"】");
		}
		return resultObject;
	}

	*//**
	 * //报备审核失败
			//【卖铺宝】您好！您于{{startDate.DATA}}提交的客户{{customerName.DATA}}在{{projectName.DATA}}项目的带看报备审核失败；为避免客户流程，请尽快联系项目经理，项目经理{{manager.DATA}} 电话：{{phone.DATA}}
	 * @param openId
	 * @return
	 *  {{startDate.DATA}}
				{{customerName.DATA}}
				{{projectName.DATA}}
				{{manager.DATA}}
				{{phone.DATA}}
	 *//*
	public String sendWxMsg_AuditFail(Map<String, Object> map)throws Exception {
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("startDate", WechatTemplate.item(map.get("startDate")+"", "#000000"));
		params.put("customerName", WechatTemplate.item(map.get("customerName")+"", "#000000"));
		params.put("projectName", WechatTemplate.item(map.get("projectName")+"", "#000000"));
		params.put("manager", WechatTemplate.item(map.get("manager")+"", "#000000"));
		params.put("phone", WechatTemplate.item(map.get("phone")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_audit_fail);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("板参数组装{}", sendData);

		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String retInfo = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("消息模板返回{}", retInfo);
		System.out.println("消息模板返回报文:"+retInfo);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		return retInfo;
	}

	*//**
	 * //到访成功
	 * //【卖铺宝】您好！恭喜您：您于{{startDate.DATA}}提交的客户{{customerName.DATA}}在{{projectName.DATA}}项目已确认到访；保护截至日期为{{endDate.DATA}}。项目经理{{manager.DATA}} 电话：{{phone.DATA}}
	 * @param map
	 * @return
	 * @throws Exception
				{{startDate.DATA}}
				{{customerName.DATA}}
				{{projectName.DATA}}
				{{endDate.DATA}}
				{{manager.DATA}}
				{{phone.DATA}}
	 *//*
	public String sendWxMsg_DaoFang(Map<String, Object> map) throws Exception{
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("startDate", WechatTemplate.item(map.get("startDate")+"", "#000000"));
		params.put("customerName", WechatTemplate.item(map.get("customerName")+"", "#000000"));
		params.put("projectName", WechatTemplate.item(map.get("projectName")+"", "#000000"));
		params.put("endDate", WechatTemplate.item(map.get("endDate")+"", "#000000"));
		params.put("manager", WechatTemplate.item(map.get("manager")+"", "#000000"));
		params.put("phone", WechatTemplate.item(map.get("phone")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_daofang);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("板参数组装{}", sendData);

		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String retInfo = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("消息模板返回{}", retInfo);
		System.out.println("消息模板返回报文:"+retInfo);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		return retInfo;
	}

	*//**
	 * //认购成功
				//【卖铺宝】您好！恭喜您：您于{{startDate.DATA}} 提交的客户{{customerName.DATA}}在{{projectName.DATA}}项目已成功认购； 认购日期{{endDate.DATA}}.认购详情请登录卖铺宝app进行查看。项目经理{{manager.DATA}} 电话：{{phone.DATA}}
	 * @param openId
	 * @return
	 *  {{startDate.DATA}}
				{{customerName.DATA}}
				{{projectName.DATA}}
				{{endDate.DATA}}
				{{manager.DATA}}
				{{phone.DATA}}
	 *//*
	public String sendWxMsg_RenGou(Map<String, Object> map) throws Exception{
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("startDate", WechatTemplate.item(map.get("startDate")+"", "#000000"));
		params.put("customerName", WechatTemplate.item(map.get("customerName")+"", "#000000"));
		params.put("projectName", WechatTemplate.item(map.get("projectName")+"", "#000000"));
		params.put("endDate", WechatTemplate.item(map.get("endDate")+"", "#000000"));
		params.put("manager", WechatTemplate.item(map.get("manager")+"", "#000000"));
		params.put("phone", WechatTemplate.item(map.get("phone")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_rengou);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("板参数组装{}", sendData);

		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String retInfo = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("消息模板返回{}", retInfo);
		System.out.println("消息模板返回报文:"+retInfo);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		return retInfo;
	}

	*//**
	 * //签约成功
			//【卖铺宝】您好！恭喜您：您于{{startDate.DATA}} 提交的客户{{customerName.DATA}}在{{projectName.DATA}}楼盘已成功签约；签约日期{{endDate.DATA}}，签约详情请登录卖铺宝app进行查看，项目经理{{manager.DATA}} 电话：{{phone.DATA}}
	 * @param openId
	 * @return
	 *  {{startDate.DATA}}
				{{customerName.DATA}}
				{{projectName.DATA}}
				{{endDate.DATA}}
				{{manager.DATA}}
				{{phone.DATA}}
	 *//*
	public String sendWxMsg_QianYue(Map<String, Object> map)throws Exception {
		String openId=map.get("openId")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("startDate", WechatTemplate.item(map.get("startDate")+"", "#000000"));
		params.put("customerName", WechatTemplate.item(map.get("customerName")+"", "#000000"));
		params.put("projectName", WechatTemplate.item(map.get("projectName")+"", "#000000"));
		params.put("endDate", WechatTemplate.item(map.get("endDate")+"", "#000000"));
		params.put("manager", WechatTemplate.item(map.get("manager")+"", "#000000"));
		params.put("phone", WechatTemplate.item(map.get("phone")+"", "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_qianyue);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("板参数组装{}", sendData);
		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		treeMap.put("access_token", this.getAccessToken());
		String retInfo = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("消息模板返回{}", retInfo);
		System.out.println("消息模板返回报文:"+retInfo);//消息模板返回报文:{"errcode":48001,"errmsg":"api unauthorized hints: [xgIczQaLRa-j6J3MA!]"}
		return retInfo;
	}*/

	/**
	 * 发送消息-公用
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public ResultObject sendMsgToGzhCommon(Map<String, Object> map)throws Exception {
		ResultObject resultObject=new ResultObject();
		String openId=map.get("openId")+"";
		String accessToken=map.get("accessToken")+"";
		String remark=map.get("remark")+"";
		TreeMap<String, TreeMap<String, String>> params = new TreeMap<String, TreeMap<String, String>>();
		//根据具体模板参数组装
		params.put("first",  WechatTemplate.item("","#000000"));
        String createDate=DateUtils.format(new Date(), "yyyy-MM-dd HH:mm:ss");
		params.put("keyword1", WechatTemplate.item(createDate, "#000000"));
		params.put("keyword2", WechatTemplate.item("消息提醒", "#000000"));
		params.put("remark", WechatTemplate.item(remark, "#000000"));
		WechatTemplate wechatTemplate = new WechatTemplate();
		wechatTemplate.setTemplate_id(temp_id_audit_succ);
		wechatTemplate.setTouser(openId);
		wechatTemplate.setUrl(url);
		wechatTemplate.setData(params);
		JSONObject json = (JSONObject) JSONObject.toJSON(wechatTemplate);//将java对象转换为json对象
		String sendData = json.toString();//将json对象转换为字符串
		logger.info("【TreeMap-发送公众号消息-请求入参："+sendData);
		TreeMap<String, String> treeMap = new TreeMap<String, String>();
		//treeMap.put("access_token", this.getAccessToken());
		treeMap.put("access_token", accessToken);
		String resultObj = WxPublicAccountHttpUtil.doPost(SEND_TEMPLATE_MESSAGE_URL, treeMap, sendData);
		logger.info("【TreeMap-发送公众号消息-返回报文:"+resultObj+"】");
		JSONObject JsonMsg = JSONObject.parseObject(resultObj);
		if(!"0".equals(JsonMsg.get("errcode")+"")){
			resultObject.setCode(Constant.CODE_EXCEPTION);
			resultObject.setMessage("【向用户openId（"+openId+"）发送公众号消息失败。返回报文"+JsonMsg+"】");
			logger.info("【向用户openId（"+openId+"）发送公众号消息失败。返回报文"+JsonMsg+"】");
		}
		return resultObject;
	}
	
	public static void main(String[] args) {
		try {
			WxPublicAccountSMSUtil  wt=new WxPublicAccountSMSUtil();
			String code="061Pj2Df0gg0fw1xEPFf0KaPCf0Pj2DV";
			wt.testSendWxMsg("-1");
			
			Map<String,Object> wtMap=new HashMap<String, Object>();
			wtMap.put("openId", "o407CwqCMv1AOwJSnMH12PFaUakw");
			wtMap.put("createDate",DateUtils.format(new Date(), "yyyy-MM-dd HH:mm:ss"));
			wtMap.put("remark", "将派客服人员跟您联系感谢您的宝贵建议。谢谢");
			wt.sendMsgToGzhCommon(wtMap);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	
	
}
