package com.up.sell.vo;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BrandDatabase {
    /**
     * 
     */
    private Integer id;

    /**
     * 审核状态标识 （数据来源于字典表108）
     */
    private Integer flag;

    /**
     * 品牌状态标识 （数据来源于字典表113）
     */
    private Integer brandStatus;

    /**
     * 品牌名称
     */
    private String brandName;

    /**
     * LOGO图片路径
     */
    private String logo;

    /**
     * 品牌图片：多张图片;号隔开
     */
    private String brandPic;

    /**
     * 品牌定位（数据来源于字典表123）
     */
    private Integer brandPositioning;

    /**
     * 品牌类型（数据来源于字典表124）
     */
    private Integer brandType;

    /**
     * 品牌经营性质（数据来源于字典表125）
     */
    private String brandNature;

    /**
     * 品牌面积需求（数据来源于字典表126）
     */
    private Integer areas;

    /**
     * 品牌业态:一级，brand_business表的ID
     */
    private Integer brandBusinessOne;

    /**
     * 品牌业态:二级，brand_business表的ID
     */
    private Integer brandBusinessTwo;

    /**
     * 公司全称
     */
    private String companyName;

    /**
     * 特殊需求
     */
    private String specialRequirements;

    /**
     * 品牌介绍
     */
    private String description;

    /**
     * 店铺数量
     */
    private Integer shopsCount;

    /**
     * 品牌成立时间
     */
    private Date brandCreateTime;

    /**
     * 今年开店计划
     */
    private Integer planShopsCount;

    /**
     * 是否置顶：0不置顶、1置顶
     */
    private Integer topFlag;

    /**
     * 置顶开始时间
     */
    private Date topBeginTime;

    /**
     * 置顶结束时间
     */
    private Date topEndTime;

    /**
     * 发布时所在省ID
     */
    private String provinceId;

    /**
     * 发布时所在市ID
     */
    private String cityId;

    /**
     * 会员ID
     */
    private Integer memberId;

    /**
     * 创建人,user表ID
     */
    private Integer createUser;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 最后更新人,user表ID
     */
    private Integer updateUser;

    /**
     * 最后更新时间
     */
    private Date updateTime;

    /**
     * 审批人,user表ID
     */
    private Integer approveUser;

    /**
     * 审批时间
     */
    private Date approveTime;

    /**
     * 审批意见
     */
    private String reasons;

    private List<BrandExpandArea> brandExpandAreaList = new ArrayList<BrandExpandArea>();
    
    private List<BrandContacts> brandContactsList = new ArrayList<BrandContacts>();
    
    //********************************************************************************************
    private String brandBusiness;
    
    private String brandExpandArea;
    
    /**
     * 手机号码
     */
    private String mobile1;

    /**
     * 真实姓名
     */
    private String userName1;
    /**
     */
    private Integer post1;
   
    private String brandContactsArea1;
    
    /**
     * 手机号码
     */
    private String mobile2;

    /**
     * 真实姓名
     */
    private String userName2;
    /**
     */
    private Integer post2;
   
    private String brandContactsArea2;
    
    /**
     * 品牌来源（0：后台新增 1：app新增）
     */
    private Integer sourceType;
   
    public Integer getSourceType() {
		return sourceType;
	}

	public void setSourceType(Integer sourceType) {
		this.sourceType = sourceType;
	}

	public String getBrandBusiness() {
		return brandBusiness;
	}

	public void setBrandBusiness(String brandBusiness) {
		this.brandBusiness = brandBusiness;
	}

	public String getBrandExpandArea() {
		return brandExpandArea;
	}

	public void setBrandExpandArea(String brandExpandArea) {
		this.brandExpandArea = brandExpandArea;
	}

	public String getMobile1() {
		return mobile1;
	}

	public void setMobile1(String mobile1) {
		this.mobile1 = mobile1;
	}

	public String getUserName1() {
		return userName1;
	}

	public void setUserName1(String userName1) {
		this.userName1 = userName1;
	}

	public Integer getPost1() {
		return post1;
	}

	public void setPost1(Integer post1) {
		this.post1 = post1;
	}

	public String getBrandContactsArea1() {
		return brandContactsArea1;
	}

	public void setBrandContactsArea1(String brandContactsArea1) {
		this.brandContactsArea1 = brandContactsArea1;
	}

	public String getMobile2() {
		return mobile2;
	}

	public void setMobile2(String mobile2) {
		this.mobile2 = mobile2;
	}

	public String getUserName2() {
		return userName2;
	}

	public void setUserName2(String userName2) {
		this.userName2 = userName2;
	}

	public Integer getPost2() {
		return post2;
	}

	public void setPost2(Integer post2) {
		this.post2 = post2;
	}

	public String getBrandContactsArea2() {
		return brandContactsArea2;
	}

	public void setBrandContactsArea2(String brandContactsArea2) {
		this.brandContactsArea2 = brandContactsArea2;
	}

	public List<BrandExpandArea> getBrandExpandAreaList() {
		return brandExpandAreaList;
	}

	public void setBrandExpandAreaList(List<BrandExpandArea> brandExpandAreaList) {
		this.brandExpandAreaList = brandExpandAreaList;
	}

	public List<BrandContacts> getBrandContactsList() {
		return brandContactsList;
	}

	public void setBrandContactsList(List<BrandContacts> brandContactsList) {
		this.brandContactsList = brandContactsList;
	}

	/**
     * 
     * @return id 
     */
    public Integer getId() {
        return id;
    }

    /**
     * 
     * @param id 
     */
    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * 审核状态标识 （数据来源于字典表108）
     * @return flag 审核状态标识 （数据来源于字典表108）
     */
    public Integer getFlag() {
        return flag;
    }

    /**
     * 审核状态标识 （数据来源于字典表108）
     * @param flag 审核状态标识 （数据来源于字典表108）
     */
    public void setFlag(Integer flag) {
        this.flag = flag;
    }

    /**
     * 品牌状态标识 （数据来源于字典表113）
     * @return brand_status 品牌状态标识 （数据来源于字典表113）
     */
    public Integer getBrandStatus() {
        return brandStatus;
    }

    /**
     * 品牌状态标识 （数据来源于字典表113）
     * @param brandStatus 品牌状态标识 （数据来源于字典表113）
     */
    public void setBrandStatus(Integer brandStatus) {
        this.brandStatus = brandStatus;
    }

    /**
     * 品牌名称
     * @return brand_name 品牌名称
     */
    public String getBrandName() {
        return brandName;
    }

    /**
     * 品牌名称
     * @param brandName 品牌名称
     */
    public void setBrandName(String brandName) {
        this.brandName = brandName == null ? null : brandName.trim();
    }

    /**
     * LOGO图片路径
     * @return logo LOGO图片路径
     */
    public String getLogo() {
        return logo;
    }

    /**
     * LOGO图片路径
     * @param logo LOGO图片路径
     */
    public void setLogo(String logo) {
        this.logo = logo == null ? null : logo.trim();
    }

    /**
     * 品牌图片：多张图片;号隔开
     * @return brand_pic 品牌图片：多张图片;号隔开
     */
    public String getBrandPic() {
        return brandPic;
    }

    /**
     * 品牌图片：多张图片;号隔开
     * @param brandPic 品牌图片：多张图片;号隔开
     */
    public void setBrandPic(String brandPic) {
        this.brandPic = brandPic == null ? null : brandPic.trim();
    }

    /**
     * 品牌定位（数据来源于字典表123）
     * @return brand_positioning 品牌定位（数据来源于字典表123）
     */
    public Integer getBrandPositioning() {
        return brandPositioning;
    }

    /**
     * 品牌定位（数据来源于字典表123）
     * @param brandPositioning 品牌定位（数据来源于字典表123）
     */
    public void setBrandPositioning(Integer brandPositioning) {
        this.brandPositioning = brandPositioning;
    }

    /**
     * 品牌类型（数据来源于字典表124）
     * @return brand_type 品牌类型（数据来源于字典表124）
     */
    public Integer getBrandType() {
        return brandType;
    }

    /**
     * 品牌类型（数据来源于字典表124）
     * @param brandType 品牌类型（数据来源于字典表124）
     */
    public void setBrandType(Integer brandType) {
        this.brandType = brandType;
    }

    /**
     * 品牌经营性质（数据来源于字典表125）
     * @return brand_nature 品牌经营性质（数据来源于字典表125）
     */
    public String getBrandNature() {
        return brandNature;
    }

    public void setBrandNature(String brandNature) {
        this.brandNature = brandNature;
    }

    /**
     * 品牌面积需求（数据来源于字典表126）
     * @return areas 品牌面积需求（数据来源于字典表126）
     */
    public Integer getAreas() {
        return areas;
    }

    /**
     * 品牌面积需求（数据来源于字典表126）
     * @param areas 品牌面积需求（数据来源于字典表126）
     */
    public void setAreas(Integer areas) {
        this.areas = areas;
    }

    /**
     * 品牌业态:一级，brand_business表的ID
     * @return brand_business_one 品牌业态:一级，brand_business表的ID
     */
    public Integer getBrandBusinessOne() {
        return brandBusinessOne;
    }

    /**
     * 品牌业态:一级，brand_business表的ID
     * @param brandBusinessOne 品牌业态:一级，brand_business表的ID
     */
    public void setBrandBusinessOne(Integer brandBusinessOne) {
        this.brandBusinessOne = brandBusinessOne;
    }

    /**
     * 品牌业态:二级，brand_business表的ID
     * @return brand_business_two 品牌业态:二级，brand_business表的ID
     */
    public Integer getBrandBusinessTwo() {
        return brandBusinessTwo;
    }

    /**
     * 品牌业态:二级，brand_business表的ID
     * @param brandBusinessTwo 品牌业态:二级，brand_business表的ID
     */
    public void setBrandBusinessTwo(Integer brandBusinessTwo) {
        this.brandBusinessTwo = brandBusinessTwo;
    }

    /**
     * 公司全称
     * @return company_name 公司全称
     */
    public String getCompanyName() {
        return companyName;
    }

    /**
     * 公司全称
     * @param companyName 公司全称
     */
    public void setCompanyName(String companyName) {
        this.companyName = companyName == null ? null : companyName.trim();
    }

    /**
     * 特殊需求
     * @return special_requirements 特殊需求
     */
    public String getSpecialRequirements() {
        return specialRequirements;
    }

    /**
     * 特殊需求
     * @param specialRequirements 特殊需求
     */
    public void setSpecialRequirements(String specialRequirements) {
        this.specialRequirements = specialRequirements == null ? null : specialRequirements.trim();
    }

    /**
     * 品牌介绍
     * @return description 品牌介绍
     */
    public String getDescription() {
        return description;
    }

    /**
     * 品牌介绍
     * @param description 品牌介绍
     */
    public void setDescription(String description) {
        this.description = description == null ? null : description.trim();
    }

    /**
     * 店铺数量
     * @return shops_count 店铺数量
     */
    public Integer getShopsCount() {
        return shopsCount;
    }

    /**
     * 店铺数量
     * @param shopsCount 店铺数量
     */
    public void setShopsCount(Integer shopsCount) {
        this.shopsCount = shopsCount;
    }

    /**
     * 品牌成立时间
     * @return brand_create_time 品牌成立时间
     */
    public Date getBrandCreateTime() {
        return brandCreateTime;
    }

    /**
     * 品牌成立时间
     * @param brandCreateTime 品牌成立时间
     */
    public void setBrandCreateTime(Date brandCreateTime) {
        this.brandCreateTime = brandCreateTime;
    }

    /**
     * 今年开店计划
     * @return plan_shops_count 今年开店计划
     */
    public Integer getPlanShopsCount() {
        return planShopsCount;
    }

    /**
     * 今年开店计划
     * @param planShopsCount 今年开店计划
     */
    public void setPlanShopsCount(Integer planShopsCount) {
        this.planShopsCount = planShopsCount;
    }

    /**
     * 是否置顶：0不置顶、1置顶
     * @return top_flag 是否置顶：0不置顶、1置顶
     */
    public Integer getTopFlag() {
        return topFlag;
    }

    /**
     * 是否置顶：0不置顶、1置顶
     * @param topFlag 是否置顶：0不置顶、1置顶
     */
    public void setTopFlag(Integer topFlag) {
        this.topFlag = topFlag;
    }

    /**
     * 置顶开始时间
     * @return top_begin_time 置顶开始时间
     */
    public Date getTopBeginTime() {
        return topBeginTime;
    }

    /**
     * 置顶开始时间
     * @param topBeginTime 置顶开始时间
     */
    public void setTopBeginTime(Date topBeginTime) {
        this.topBeginTime = topBeginTime;
    }

    /**
     * 置顶结束时间
     * @return top_end_time 置顶结束时间
     */
    public Date getTopEndTime() {
        return topEndTime;
    }

    /**
     * 置顶结束时间
     * @param topEndTime 置顶结束时间
     */
    public void setTopEndTime(Date topEndTime) {
        this.topEndTime = topEndTime;
    }

    /**
     * 发布时所在省ID
     * @return province_id 发布时所在省ID
     */
    public String getProvinceId() {
        return provinceId;
    }

    /**
     * 发布时所在省ID
     * @param provinceId 发布时所在省ID
     */
    public void setProvinceId(String provinceId) {
        this.provinceId = provinceId == null ? null : provinceId.trim();
    }

    /**
     * 发布时所在市ID
     * @return city_id 发布时所在市ID
     */
    public String getCityId() {
        return cityId;
    }

    /**
     * 发布时所在市ID
     * @param cityId 发布时所在市ID
     */
    public void setCityId(String cityId) {
        this.cityId = cityId == null ? null : cityId.trim();
    }

    /**
     * 会员ID
     * @return member_id 会员ID
     */
    public Integer getMemberId() {
        return memberId;
    }

    /**
     * 会员ID
     * @param memberId 会员ID
     */
    public void setMemberId(Integer memberId) {
        this.memberId = memberId;
    }

    /**
     * 创建人,user表ID
     * @return create_user 创建人,user表ID
     */
    public Integer getCreateUser() {
        return createUser;
    }

    /**
     * 创建人,user表ID
     * @param createUser 创建人,user表ID
     */
    public void setCreateUser(Integer createUser) {
        this.createUser = createUser;
    }

    /**
     * 创建时间
     * @return create_time 创建时间
     */
    public Date getCreateTime() {
        return createTime;
    }

    /**
     * 创建时间
     * @param createTime 创建时间
     */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    /**
     * 最后更新人,user表ID
     * @return update_user 最后更新人,user表ID
     */
    public Integer getUpdateUser() {
        return updateUser;
    }

    /**
     * 最后更新人,user表ID
     * @param updateUser 最后更新人,user表ID
     */
    public void setUpdateUser(Integer updateUser) {
        this.updateUser = updateUser;
    }

    /**
     * 最后更新时间
     * @return update_time 最后更新时间
     */
    public Date getUpdateTime() {
        return updateTime;
    }

    /**
     * 最后更新时间
     * @param updateTime 最后更新时间
     */
    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    /**
     * 审批人,user表ID
     * @return approve_user 审批人,user表ID
     */
    public Integer getApproveUser() {
        return approveUser;
    }

    /**
     * 审批人,user表ID
     * @param approveUser 审批人,user表ID
     */
    public void setApproveUser(Integer approveUser) {
        this.approveUser = approveUser;
    }

    /**
     * 审批时间
     * @return approve_time 审批时间
     */
    public Date getApproveTime() {
        return approveTime;
    }

    /**
     * 审批时间
     * @param approveTime 审批时间
     */
    public void setApproveTime(Date approveTime) {
        this.approveTime = approveTime;
    }

    /**
     * 审批意见
     * @return reasons 审批意见
     */
    public String getReasons() {
        return reasons;
    }

    /**
     * 审批意见
     * @param reasons 审批意见
     */
    public void setReasons(String reasons) {
        this.reasons = reasons == null ? null : reasons.trim();
    }
}